'--------------------------------------------------------------------------------------------------------------
' Factura-Software Scriptdatei 
' Funktion: Umsatzsteuer fr alle Positionen eines Belegs setzen
' Ansicht:  FakturaBelege
' Script:	FakturaBelege_55_Beleg_Ust_setzen.vbs
' Produkt:	combit Relationship Manager 5
' Autor  :  Andreas Mller

' Faktura-Software.net macht keine Angaben zu einer bestimmten Eignung der Information in diesem Script
' Irrtmer und Fehler bleiben ausdrcklich vorbehalten und die Angaben erfolgen ohne Gewhr. 
' Die Angaben stellen nur Einzelfallszenarien dar und enthalten keine Garantie der Beschaffenheit 
' der Produkte. 
 
' Copyright (c) by Faktura-Software.net. Alle Rechte vorbehalten.
'--------------------------------------------------------------------------------------------------------------


Option Explicit
<!--#include file="%PRJDIR%\script\CosmoOle.vbs"-->

'--------------------------------------------------------------------------------------------------------------
' Begin Versionierung
'--------------------------------------------------------------------------------------------------------------
Dim sSkriptVersion
sSkriptVersion = "002"
'--------------------------------------------------------------------------------------------------------------
' What's new
'--------------------------------------------------------------------------------------------------------------
' Version 002 
' - 
'--------------------------------------------------------------------------------------------------------------

Dim sErrorCode, sErrorProjekt, sErrorAnsicht, sErrorSkript

sErrorProjekt   = cRM.CurrentProject.GetSessionProperty("cRM_Projekt_ProjektNr",True)
sErrorAnsicht   = "118"
sErrorSkript    = "055"

sErrorCode =  sErrorProjekt & sErrorAnsicht & sErrorSkript

'--------------------------------------------------------------------------------------------------------------
' Ende Versionierung
'--------------------------------------------------------------------------------------------------------------

'Loginuser ermitteln
Dim sErf_User

sErf_User = cRM.CurrentProject.CurrentUser

'Recordid des Belegs -wenn "" dann Ende
Dim sRecordid

sRecordid = GetViewContentByName("Recordid")

if sRecordid = "" Then
  
  Wscript.Quit
End If


'Ust abfragen
Dim dUst
dUst = ZahlEingeben("Wert: "," Mehrwertsteuer belegweit setzen",0)

If dUst = False Then
  showmessage("fehlerhafte Eingabe. Vorgang wird beendet.")
  WScript.Quit
End If
dUst =CDbl(dUst)
dUst = StringReplace(dUst,".",",")
'Sicherheitsabfrage:

If showquestion("Die Mehrwertsteuer aller Positionen zu diesem Beleg wird auf " &dUst & " gesetzt. Der Vorgang kann nicht rckgngig gemacht werden. Fortfahren?") = True Then
  	'---------------------------------------------------------------------------------------------------------------------------
	' Lagerfhige Positionen in Buchungsliste bertragen
	'--------------------------------------------------------------------------------------------------------------------------- 
	Dim sProcedure, sTrennzeichen, sParameter,bSP
	 
	 
	 sProcedure = "Fs_Beleg_Ust_Setzen"
	 sTrennzeichen = ";"
	 sParameter = sRecordid & ";" &  dUst & ";" & sErf_User
	 'showmessage(sParameter)
	 bSP = (FakturaProcedure( sProcedure,sTrennzeichen,sParameter,sErrorCode & "001"))
	 'showmessage(sProcedure)
	If bSP = false Then
	
	      'RaiseException("ErrorCode:" & sErrorCode & "001" & vbLF & vbLF & "Interner Fehler. " & vbLF & "Das Script wird nicht fortgesetzt. Bitte kontaktieren Sie den Support")
	      Wscript.Quit
	End If
Else
 Showmessage("Vorgang abgebrochen")
End If

' Aktive Ansicht aktualisieren:
cRM.CurrentProject.ActiveViews.ActiveView.Update

