'--------------------------------------------------------------------------------------------------------------
' Faktura-Software Scriptdatei 
' Funktion: 	Kopie der Preisgruppe inkl. Warengruppen unter neuer Bezeichnung
' Ansicht:  	FakturaPreisgruppen
' Script:	FakturaPreisgruppen_01_Preisgruppe_Kopieren.vbs
' Produkt:	combit Relationship Manager 5
' Autor  :  	Andreas Mller

' Faktura-Software.net macht keine Angaben zu einer bestimmten Eignung der Information in diesem Script
' Irrtmer und Fehler bleiben ausdrcklich vorbehalten und die Angaben erfolgen ohne Gewhr. 
' Die Angaben stellen nur Einzelfallszenarien dar und enthalten keine Garantie der Beschaffenheit 
' der Produkte. 
 
' Copyright (c) by Faktura-Software.net. Alle Rechte vorbehalten.
'--------------------------------------------------------------------------------------------------------------

Option Explicit

<!--#include file="%PRJDIR%\script\CosmoOle.vbs"-->


'--------------------------------------------------------------------------------------------------------------
' Begin Versionierung
'--------------------------------------------------------------------------------------------------------------
Dim sSkriptVersion
sSkriptVersion = "001"
'--------------------------------------------------------------------------------------------------------------
' What's new
'--------------------------------------------------------------------------------------------------------------
' Version 002 Patch 028 16.05.2012 neu alles (mit und ohne Rabatt) ber eine SP (sProcedure    = "Fs_Preisgruppe_Kopieren") realisiert
' - sProcedure    = "Fs_Preisgruppe_Kopieren_mit_Rabatt" ist raus
'--------------------------------------------------------------------------------------------------------------
' Version 003
' - 
'--------------------------------------------------------------------------------------------------------------

Dim sErrorCode, sErrorProjekt, sErrorAnsicht, sErrorSkript

sErrorProjekt   = cRM.CurrentProject.GetSessionProperty("cRM_Projekt_ProjektNr",True)
sErrorAnsicht   = "154"
sErrorSkript    = "001"

sErrorCode =  sErrorProjekt & sErrorAnsicht & sErrorSkript

'--------------------------------------------------------------------------------------------------------------
' Ende Versionierung
'--------------------------------------------------------------------------------------------------------------




'----- 1. Artikelnummer neu eingeben -----
Dim sPreisgruppenID,sBezeichnung_Alt,sBezeichnung

sPreisgruppenID = Crm.CurrentProject.ActiveViews.ActiveView.CurrentRecordSet.CurrentRecordSynchronized.GetContentsByName("Recordid")
sBezeichnung_Alt = Crm.CurrentProject.ActiveViews.ActiveView.CurrentRecordSet.CurrentRecordSynchronized.GetContentsByName("Bezeichnung")
If sPreisgruppenID = "" Then
  Wscript.Quit
End If


sBezeichnung = inputBox("Neue Bezeichnung eingeben: ","Preisgruppe kopieren" ,sBezeichnung_Alt & " - Kopie")

If sBezeichnung = "" Then
  WScript.Quit
End If

'-----2. Erfassungsdatum und Erfassungsbenutzer auslesen

Dim sErfUser

sErfUser = Crm.CurrentProject.CurrentUser

Dim sRabatt


If WScript.RightClicked Then
 
  
  sRabatt = inputBox("Rabatt eingeben " & vbLf _
  		  & "+ <Zahl> erhht jeden Rabatt " & vbLf _ 
  		  & "- <Zahl> reduziert jeden Rabatt " & vbLf _
  		  & "<Zahl> setzt jeden Rabatt auf <Zahl> " & vbLf _
  		  & "Keine Eingabe behlt jeden Rabatt wie gehabt ","Preisgruppe kopieren" ,"")
  		  
  If sRabatt = "" Then 
    sRabatt = "999"
  End If		  
End If

sRabatt = StringReplace (sRabatt, ",", ".")


'-----3. Stored Procedure starten -----

Dim sProcedure,sTrennzeichen,sParameter
Dim bSP 

If sRabatt = "" Then



	 sProcedure    = "Fs_Preisgruppe_Kopieren"
	 sTrennzeichen = ";"
	 sParameter    = sPreisgruppenID & ";" & sBezeichnung & ";" & sErfUser
	 
	 
	
	 
  
Else

 	 'sProcedure    = "Fs_Preisgruppe_Kopieren_mit_Rabatt"
	 sProcedure    = "Fs_Preisgruppe_Kopieren"
	 sTrennzeichen = ";"
	 sParameter    = sPreisgruppenID & ";" & sBezeichnung & ";" & sErfUser & ";" & sRabatt


End If
  

'showmessage(sParameter)
'WScript.Quit
bSP = (FakturaProcedure( sProcedure,sTrennzeichen,sParameter,sErrorCode & "001"))
	   
	 if bSP = False Then
	   'RaiseException("ErrorCode:" & sErrorCode & "001" & vbLF & vbLF & "Interner Fehler. " & vbLF & "Das Script wird nicht fortgesetzt. Bitte kontaktieren Sie den Support")
	   Wscript.Quit
	 End If


Dim sFilter
'Filter auf den neu angelegten Datensatz
sFilter="select ""Factura_Preisgruppen"".""Recordid"" from ""Factura_Preisgruppen"" where ""Factura_Preisgruppen"".""Erf_Dat"" = (select max(""Factura_Preisgruppen"".""Erf_Dat"") "_
		&" from ""Factura_Preisgruppen"") and ""Factura_Preisgruppen"".""Erf_User"" = '" & sErfUser & "'"
	
SetFilterDirectSQL(sFilter)

