' Faktura-Software Scriptdatei 
' Funktion:	Skipt fr die Datevschnittstelle
' Ansicht:  	Fakturabersicht
' Script:	FakturaUebersicht_99_Datev_ausfhren.vbs
' Produkt:	combit Relationship Manager 6
' Autor  :  	Dr. Frank Wietzel

' Faktura-Software.net macht keine Angaben zu einer bestimmten Eignung der Information in diesem Script
' Irrtmer und Fehler bleiben ausdrcklich vorbehalten und die Angaben erfolgen ohne Gewhr. 
' Die Angaben stellen nur Einzelfallszenarien dar und enthalten keine Garantie der Beschaffenheit 
' der Produkte. 
 
' Copyright (c) by Faktura-Software.net. Alle Rechte vorbehalten.
'--------------------------------------------------------------------------------------------------------------


Option Explicit
<!--#include file="%PRJDIR%\script\CosmoOle.vbs"-->

Dim bDebugMode

bDebugMode = 0

'--------------------------------------------------------------------------------------------------------------
' Begin Versionierung
'--------------------------------------------------------------------------------------------------------------
Dim sSkriptVersion
sSkriptVersion = "002"
'--------------------------------------------------------------------------------------------------------------
' What's new
'--------------------------------------------------------------------------------------------------------------
' Version 002 (16.02.2012)
' - Erweitlerung Objekt objDatev.EULand	= sEULand Deutschland (DE) entfernt if (sEULand <> " ") and  len (sEULand)>0 And (sEULand <> "DE") 
'--------------------------------------------------------------------------------------------------------------
' Version 003 
' 
'--------------------------------------------------------------------------------------------------------------

Dim sErrorCode, sErrorProjekt, sErrorAnsicht, sErrorSkript, sErfuser

sErrorProjekt   = cRM.CurrentProject.GetSessionProperty("cRM_Projekt_ProjektNr",True)
sErrorAnsicht   = "117"
sErrorSkript    = "099"

sErrorCode =  sErrorProjekt & sErrorAnsicht & sErrorSkript

sErfuser       = Crm.CurrentProject.CurrentUser

'--------------------------------------------------------------------------------------------------------------
' Ende Versionierung
'--------------------------------------------------------------------------------------------------------------

'--------------------------------------------------------------------------------------------------------------
'01 Properties fr Steuerberater und Parameter
'--------------------------------------------------------------------------------------------------------------
Dim sBeraterNummer, sBeraterName, sMandatnr, iSKLenDaten, iSKLenStammdaten, iAbrechnungsNummer, sDatevBuchungsart,sOnErrorErloesKto,sOnErrorKdNr

Dim sIniDatei, sStdErloes1, sStdErloes2, sStdErloes3,sStdErloes4,sStdErloes5,sStdErloes6,sStdErloes7, bEinnahmeueberschuss, sStdErloes

sIniDatei = "%PRJDIR%\script\Faktura-Software.ini"

Dim sFactura_Version,sFakturaBelege

'combit Ansicht fr die Faktura Belege
'sFakturaBelege = "Factura_Belege"
sFakturaBelege = "FakturaBelege"

sFactura_Version = cRM.CurrentProject.GetSessionProperty("cRM_Projekt_Factura_Version",True) ' Projekt     3 Stellig


If Not FileExists(sIniDatei) Then
  ShowMessage("Die Datev-Schnittstellet konnte nicht initialisiert werden, da auf die Datei "&sIniDate &" nicht existiert." )
End if


sBeraterNummer		= ReadIniFile(sIniDatei,"Datev-Schnittstelle", "BeraterNummer") '"6814"
sBeraterName		= ReadIniFile(sIniDatei,"Datev-Schnittstelle", "BeraterName") '"BAUMANN"
sMandatnr			= ReadIniFile(sIniDatei,"Datev-Schnittstelle", "Mandatnr") ' "174" 
iSKLenDaten		= ReadIniFile(sIniDatei,"Datev-Schnittstelle", "SKLendaten") '4
iSKLenStammdaten	= ReadIniFile(sIniDatei,"Datev-Schnittstelle", "SKLenStammdaten") '4
'iAbrechnungsNummer 	= ReadIniFile(sIniDatei,"Datev-Schnittstelle", "AbrechnungsNummer") '1
iAbrechnungsNummer 	= ReadIniFile(sIniDatei,"Datev-Schnittstelle", "DTNummer") '1
sStdErloes1			= ReadIniFile(sIniDatei,"Datev-Schnittstelle", "Std-ErloesKto1") '4400 (DE 19%)
sStdErloes2			= ReadIniFile(sIniDatei,"Datev-Schnittstelle", "Std-ErloesKto2") '4300 (DE 7%)
sStdErloes3			= ReadIniFile(sIniDatei,"Datev-Schnittstelle", "Std-ErloesKto3") '4110 (DE 0%)
sStdErloes4			= ReadIniFile(sIniDatei,"Datev-Schnittstelle", "Std-ErloesKto4") '4125 (EU mit UST-ID 0%)
sStdErloes5			= ReadIniFile(sIniDatei,"Datev-Schnittstelle", "Std-ErloesKto5") '4315 (EU ohne UST-ID 19%)
sStdErloes6			= ReadIniFile(sIniDatei,"Datev-Schnittstelle", "Std-ErloesKto6") '4310 (EU ohne UST-ID 7%)
sStdErloes7			= ReadIniFile(sIniDatei,"Datev-Schnittstelle", "Std-ErloesKto7") '4310 (Drittland mit oder ohne UST-ID 0%)
bEinnahmeueberschuss	= ReadIniFile(sIniDatei,"Faktura", "Einnahmenueberschussrechnung") 'false 'bei true zaehlen die Bezahlten rechnungen
sDatevBuchungsart	= ReadIniFile(sIniDatei,"Datev-Schnittstelle", "Datev-Buchungsart") '1 steht fr Belege 2 steht fr Belegpositionen buchen
sOnErrorErloesKto		= ReadIniFile(sIniDatei,"Datev-Schnittstelle", "OnErrorErloesKto") '4400 z.B.
sOnErrorKdNr		= ReadIniFile(sIniDatei,"Datev-Schnittstelle", "sOnErrorKdNr") '10000 z.B.

'Standard Erls Konto, das in 98% der Flle Auftritt
sStdErloes = sStdErloes1

'Datev Export Stammdaten Steuerberater und Abfrage was in den Belegtxt soll

'Ordner suchen wo die daten abgelegt werden
Dim sDatevOrdner
sDatevOrdner = ReadIniFile(sIniDatei,"Datev-Schnittstelle", "ExportOrdner")		
'ShowMessage(sDatevOrdner)
if (len(sDatevOrdner) <2) or (sDatevOrdner = "") then
 sDatevOrdner  = "%PRJDIR%\Dokumente\Datev"
 'sDatevOrdner = BrowseFolder("%PRJDIR%\Dokumente\Datev", true)
End if

'sDatevOrdner = BrowseFolder(sDatevOrdner, true)
'sDatevOrdner = "C:\temp\"
'berprfen ob die Dateien bereits exisiteren
Dim bWeiter

bWeiter = true

if FileExists(sDatevOrdner &"\EV01") then
  bWeiter = ShowQuestion ("Im Ordner " &sDatevOrdner &vblf &vblf &"existieren die Dateien EV bzw ED fr den Datev-Export schon. " &vblf &vblf &"Diese Dateien werden durch diesen Vorgang berschrieben." &vblf &vblf &"Trotzdem fortfahren?"  )
End if

If not bWeiter then
  ShowMessage("Der Vorgang wird beendet. Sichern Sie die Dateien und starten Sie den Datev-Export erneut.")
  Wscript.Quit
End if


'Abrechnungszeitraum
Dim sVon, sBis, sFilter

sVon = showInputbox("Abrechnungszeitraum von", DateAdd("D", -1.0 * DatePart("D", Date) + 1, DateAdd("m", -1, Date)))
'sVon = showInputbox("Abrechnungszeitraum von", "01.06.2010")
'sVon ="01.06.2010"
if not IstDatum (sVon) then
	ShowMessage(sVon  & " ist kein gltiges Datum." & vblf & "Der Vorgang wird abgebrochen.")
	Wscript.Quit
End if

sBis = showInputbox("Abrechnungszeitraum bis", DateAdd("D", -1.0 * DatePart("D", sVon) + 0, DateAdd("m", +1, sVon)))
'sBis = showInputbox("Abrechnungszeitraum bis", DateAdd("D", -1.0 * DatePart("D", Date) + 0, DateAdd("m", +0, Date)))

If Not IstDatum (sBis) then
	ShowMessage(sBis  & " ist kein gltiges Datum." & vblf & "Der Vorgang wird abgebrochen.")
	Wscript.Quit
End If


if (sVon="") or (sBis ="") or (IstDatum (sVon)=False) or (IstDatum (sBis)=False)Then
  RaiseException("ErrorCode:" & sErrorCode & "001" & vbLF & vbLF & "Die Eingabe des Datumbereiches ist nicht korrekt. " & vbLF & "Das Script wird nicht fortgesetzt")
  Wscript.Quit
End if


'Wenn Datum gleich ist, dann soll noch ein Tag hinzugenommen werden
'if  sVon = sBis then
' sBis = DateAdd("d",1,sBis) 'Add one day from sBis
 
' ShowMessage(sBis)
'End if

Dim sDatevVon, sDatevBis

sDatevVon = StringReplace(sVon,"201","1")
sDatevVon = StringReplace(sDatevVon,".","")
sDatevVon = StringReplace(sDatevVon,"-","")

sDatevBis  = StringReplace(sBis,"201","1")
sDatevBis  = StringReplace(sDatevBis ,".","")
sDatevBis  = StringReplace(sDatevBis,"-","")


'--------------------------------------------------------------------------------------------------------------
'03 Datev-Tabelle via Prozedure befllen
'--------------------------------------------------------------------------------------------------------------
Dim sProcedure, sSPTrennzeichen, sParameter,sSessionId


sProcedure 	= "Fs_Datev"
sSPTrennzeichen 	= ";"
sSessionId		= GetGuid()


'sDatevBuchungsart 	= "2"

'bEinnahmeueberschuss	= "false"

sParameter = sErfuser & sSPTrennzeichen & sVon & sSPTrennzeichen & sBis & sSPTrennzeichen & sDatevBuchungsart & sSPTrennzeichen & bEinnahmeueberschuss & sSPTrennzeichen & sSessionId

'ShowMessage (sParameter)

'SP ausfhren um die Tabelle zu fllen
Exec_SP sProcedure, sSPTrennzeichen, sParameter


'--------------------------------------------------------------------------------------------------------------
'04 Qualittsprfung der Datenstze ob Belege ohne Buchkonto Buchgkonto oder ohne Betrag vorhanden sind
'--------------------------------------------------------------------------------------------------------------
Dim sDatevView, oView,oRecordSet, oRecord

sDatevView	= "FakturaDatevExport"

Set oView = cRM.CurrentProject.viewConfigs.ItemByName(CStr(sDatevView))

Set oRecordSet = oView.CreateRecordSet

'ShowMessage(GetCombitGuid ("42715A63-CE58-4653-8507-627FC11C3340"))
'wscript.Quit
Dim sCombitSessionGuid

sCombitSessionGuid = GetCombitGuid (sSessionId)
'sCombitSessionGuid = "fc636d51d11b98498cee8ce0c0d6c00e"

sFilter	= """Factura_Software_Datev"".""SESSION"" = 0x" & sCombitSessionGuid

if oRecordSet.SetFilter(sFilter) then 

'--------------------------------------------------------------------------------------------------------------
'04.01 Check auf Buchkonto
'--------------------------------------------------------------------------------------------------------------
sFilter = """Factura_Software_Datev"".""SESSION"" = 0x" & sCombitSessionGuid & " AND (""Factura_Software_Datev"".""Buchkonto"" IS NULL OR LEN(RTRIM(""Factura_Software_Datev"".""Buchkonto"")) = 0)"
'showmessage(sFilter)
'copytoclipboard(sFilter)
	if oRecordSet.SetFilter(sFilter) then
		if oRecordSet.RecCount > 0 then
		  ShowMessage("04.01 Check Buchkonto " &vblf &vblf  &"Beim Datev Export wurden Datenstze ohne Buchkonto exportiert. "&vblf &vblf & "Dies ist nicht mglich, die Funktion wird beendet. " &vblf &vblf &"Es wird versucht, die Belege ohne Buchungskonto anzuzeigen."  &vblf &vblf & "berprfen Sie das Buchkonto bei den entsprechenden Datenstzen und starten Sie den Datev-Export erneut.")
		  sFilter = "Select Recordid from Factura_Belege where Factura_Belege.Vorgangnr in ( Select Vorgangnr from Factura_Software_Datev where [SESSION]=0x" &sCombitSessionGuid &" and Buchkonto is null or Len(RTRIM(Buchkonto)) =0 )"
		  ActivateOpenViewSetFilterDirectSQL sFakturaBelege,sFilter
		  'Eintrge lschen wenn wir im Debugmodus sind
		  if bDebugMode = 1 then Exec_SP "Fs_Datev_DeleteSession", ";", sSessionId End if
		  Wscript.Quit
		End if
	End if

'--------------------------------------------------------------------------------------------------------------
'04.02 Check auf Buchgkonto
'--------------------------------------------------------------------------------------------------------------
sFilter = """Factura_Software_Datev"".""SESSION"" = 0x" & sCombitSessionGuid & " AND (""Factura_Software_Datev"".""Buchgkonto"" IS NULL OR LEN(RTRIM(""Factura_Software_Datev"".""Buchgkonto"")) = 0)"

	if oRecordSet.SetFilter(sFilter) then
		if oRecordSet.RecCount > 0 then
		  	if sDatevBuchungsart = "1" then
		  		'Fehler liegt im Beleg
		  		ShowMessage("04.02 Check Buchgkonto (Beleg)" &vblf &vblf  &"Beim Datev Export wurden Datenstze ohne Buchgegenkonto exportiert. " &vblf &vblf & "Dies ist nicht mglich, die Funktion wird beendet. " &vblf &vblf &"Es wird versucht, die Belege ohne Buchungegenkonto anzuzeigen."  &vblf &vblf & "berprfen Sie das Buchkonto bei den entsprechenden Datenstzen und starten Sie den Datev-Export erneut.")
		  	Else
		  		'Fehler ist in der Belegposition des Beleges zu suchen.
		  		ShowMessage("04.02 Check Buchgkonto (Pos)" &vblf &vblf  &"Beim Datev Export wurden Datenstze ohne Buchgegenkonto exportiert. " &vblf &vblf & "Dies ist nicht mglich, die Funktion wird beendet. " &vblf &vblf &"Es wird versucht, die Belege bei denen Buchungegenkonto in den Belegpositionen fehlen anzuzeigen."  &vblf &vblf & "berprfen Sie das Buchgegenkonto in den entsprechenden Datenstzen und starten Sie den Datev-Export erneut.")
		  	End if
		    sFilter = "Select Recordid from Factura_Belege where Factura_Belege.Vorgangnr in ( Select Vorgangnr from Factura_Software_Datev where [SESSION]=0x" &sCombitSessionGuid &" and Buchgkonto is null or Len(RTRIM(Buchgkonto)) =0 )"
		    ActivateOpenViewSetFilterDirectSQL sFakturaBelege,sFilter
		    'Eintrge lschen wenn wir im Debugmodus sind
		    if bDebugMode = 1 then Exec_SP "Fs_Datev_DeleteSession", ";", sSessionId End if
		    Wscript.Quit
		End if
	End if

'--------------------------------------------------------------------------------------------------------------
'04.03 Check auf Datum
'--------------------------------------------------------------------------------------------------------------
sFilter = """Factura_Software_Datev"".""SESSION"" = 0x" & sCombitSessionGuid & " AND ((""Factura_Software_Datev"".""Datum"" IS NULL OR LEN(RTRIM(""Factura_Software_Datev"".""Datum"")) = 0) "

	if oRecordSet.SetFilter(sFilter) then
		if oRecordSet.RecCount > 0 then
		    ' Fehler liegt im Beleg
		    ShowMessage("04.03 Check auf Datum" &vblf &vblf  &"Beim Datev Export wurden Datenstze ohne Betrag oder Betrag=0 exportiert. " &vblf &vblf & "Dies ist nicht mglich, die Funktion wird beendet. " &vblf &vblf &"Es wird versucht, die Belege ohne Betrag oder Betrag = 0 anzuzeigen."  &vblf &vblf & "berprfen Sie den den entsprechenden Datenstzen und starten Sie den Datev-Export erneut.")
		    sFilter = "Select Recordid from Factura_Belege where Factura_Belege.Vorgangnr in ( Select Vorgangnr from Factura_Software_Datev where [SESSION]=0x" &sCombitSessionGuid &" and Datum is null or Len(RTRIM(Datum)) =0 )"
		    ActivateOpenViewSetFilterDirectSQL sFakturaBelege,sFilter
		    'Eintrge lschen wenn wir im Debugmodus sind
		    if bDebugMode = 1 then Exec_SP "Fs_Datev_DeleteSession", ";", sSessionId End if
		    Wscript.Quit
		End if
	End if
	

'--------------------------------------------------------------------------------------------------------------
'04.04 Check auf Betrag
'--------------------------------------------------------------------------------------------------------------
sFilter = """Factura_Software_Datev"".""SESSION"" = 0x" & sCombitSessionGuid & " AND ((""Factura_Software_Datev"".""Brutto_Gesamt"" IS NULL OR LEN(RTRIM(""Factura_Software_Datev"".""Brutto_Gesamt"")) = 0)  or Brutto_Gesamt = 0 )"

	if oRecordSet.SetFilter(sFilter) then
		if oRecordSet.RecCount > 0 then
		  		'Fehler liegt im Beleg
		  		ShowMessage("04.04 Check auf Betrag" &vblf &vblf  &"Beim Datev Export wurden Datenstze ohne Brutto_Gesamt oder Brutto_Gesamt = 0 exportiert. " &vblf &vblf & "Dies ist nicht mglich, die Funktion wird beendet. " &vblf &vblf &"Es wird versucht, die Belege anzuzeigen."  &vblf &vblf & "berprfen Sie den Brutto Betrag Gesamt bei den entsprechenden Datenstzen und starten Sie den Datev-Export erneut.")
		    sFilter = "Select Recordid from Factura_Belege where Factura_Belege.Vorgangnr in ( Select Vorgangnr from Factura_Software_Datev where [SESSION]=0x" &sCombitSessionGuid &" AND ( (Buchgkonto = '4300') or (Buchgkonto = '8300') ) and Ust_Satz <> '7.00'  "
		    ActivateOpenViewSetFilterDirectSQL sFakturaBelege,sFilter
		    'Eintrge lschen wenn wir im Debugmodus sind
		    if bDebugMode = 1 then Exec_SP "Fs_Datev_DeleteSession", ";", sSessionId End if
		    Wscript.Quit
		End if
	End if

'--------------------------------------------------------------------------------------------------------------
'04.05 Check auf Automatikkonto 4300 und 8300 Ust 7%
'--------------------------------------------------------------------------------------------------------------
sFilter = """Factura_Software_Datev"".""SESSION"" = 0x" & sCombitSessionGuid & " AND ( (Buchgkonto = '4300') or (Buchgkonto = '8300') ) and Ust_Satz <> '7.00' "
	if oRecordSet.SetFilter(sFilter) then
		if oRecordSet.RecCount > 0 then
		  		'Fehler liegt im Beleg
		  		ShowMessage("04.05 Check auf Datev-Autokonten 4300 bzw 8300 Ust<> 7%" &vblf &vblf  &"Beim Datev Export wurden Datenstze mit dem Buchgkonto 4300 oder 8300 mit oder Umsatzsteuer <> 7 % exportiert. " &vblf &vblf & "Dies ist nicht mglich, die Funktion wird beendet. " &vblf &vblf &"Es wird versucht, die Belege anzuzeigen."  &vblf &vblf & "berprfen Sie das Buchgkonto bzw. die Ust. bei den entsprechenden Datenstzen und starten Sie den Datev-Export erneut.")
		    sFilter = "Select Recordid from Factura_Belege where Factura_Belege.Vorgangnr in ( Select Vorgangnr from Factura_Software_Datev where [SESSION]=0x" & sCombitSessionGuid & " AND ( (Buchgkonto = '4300') or (Buchgkonto = '8300') ) and Ust_Satz <> '7.00'   )"
		 'CopyToClipboard(sFilter)
		    ActivateOpenViewSetFilterDirectSQL sFakturaBelege,sFilter
		    'Eintrge lschen wenn wir im Debugmodus sind
		    if bDebugMode = 1 then Exec_SP "Fs_Datev_DeleteSession", ";", sSessionId End if
		    Wscript.Quit
		End if
	End if


'--------------------------------------------------------------------------------------------------------------
'04.06 Check auf Automatikkonto 4400 bzw 8400 Ust 19%
'--------------------------------------------------------------------------------------------------------------
sFilter = """Factura_Software_Datev"".""SESSION"" = 0x" & sCombitSessionGuid & " AND ( (Buchgkonto = '4400') or (Buchgkonto = '8400') ) and Ust_Satz <> '19.00' "
	if oRecordSet.SetFilter(sFilter) then
		if oRecordSet.RecCount > 0 then
		  		ShowMessage("04.06 Check auf Datev-Autokonten 4400 bzw 8400 Ust<> 19%" &vblf &vblf  & "Beim Datev Export wurden Datenstze mit dem Buchgkonto 4400 oder 8400 mit oder Umsatzsteuer <> 19 % exportiert. " &vblf &vblf & "Dies ist nicht mglich, die Funktion wird beendet. " &vblf &vblf &"Es wird versucht, die Belege anzuzeigen."  &vblf &vblf & "berprfen Sie das Buchgkonto bzw. die Ust. bei den entsprechenden Datenstzen und starten Sie den Datev-Export erneut.")
		    sFilter = "select ""Factura_Belege"".""Recordid"" from ""Factura_Belege"" where Factura_Belege.Vorgangnr in ( Select Vorgangnr from Factura_Software_Datev where [SESSION]=0x" & sCombitSessionGuid & " AND ( (Buchgkonto = '4400') or (Buchgkonto = '8400') ) and Ust_Satz <> '19.00'   )"
		 'CopyToClipboard(sFilter)
		    ActivateOpenViewSetFilterDirectSQL sFakturaBelege,sFilter
		    'Eintrge lschen wenn wir im Debugmodus sind
		    if bDebugMode = 1 then Exec_SP "Fs_Datev_DeleteSession", ";", sSessionId End if
		    Wscript.Quit
		End if
	End if

'--------------------------------------------------------------------------------------------------------------
'04.07 Check auf Automatikkonto 4140 bzw 8140 Ust 0%
'--------------------------------------------------------------------------------------------------------------
sFilter = """Factura_Software_Datev"".""SESSION"" = 0x" & sCombitSessionGuid & " AND ( (Buchgkonto = '4140') or (Buchgkonto = '8140') ) and Ust_Satz <> '0.00' "
	if oRecordSet.SetFilter(sFilter) then
		if oRecordSet.RecCount > 0 then
		  		ShowMessage("04.07 Check auf Datev-Autokonten 4140 bzw 8140 Ust 0% <> 0%" &vblf &vblf  & "Beim Datev Export wurden Datenstze mit dem Buchgkonto 4140 oder 8140 mit oder Umsatzsteuer <> 0 % exportiert. " &vblf &vblf & "Dies ist nicht mglich, die Funktion wird beendet. " &vblf &vblf &"Es wird versucht, die Belege anzuzeigen."  &vblf &vblf & "berprfen Sie das Buchgkonto bzw. die Ust. bei den entsprechenden Datenstzen und starten Sie den Datev-Export erneut.")
		    sFilter = "Select Recordid from Factura_Belege where Factura_Belege.Vorgangnr in ( Select Vorgangnr from Factura_Software_Datev where [SESSION]=0x" & sCombitSessionGuid & " AND ( (Buchgkonto = '4140') or (Buchgkonto = '8140') ) and Ust_Satz <> '0.00'   )"
		 'CopyToClipboard(sFilter)
		    ActivateOpenViewSetFilterDirectSQL sFakturaBelege,sFilter
		    'Eintrge lschen wenn wir im Debugmodus sind
		    if bDebugMode = 1 then Exec_SP "Fs_Datev_DeleteSession", ";", sSessionId End if
		    Wscript.Quit
		End if
	End if

'--------------------------------------------------------------------------------------------------------------
'04.08 Check auf Automatikkonto 4150 bzw 8150 Ust 0%
'--------------------------------------------------------------------------------------------------------------
sFilter = """Factura_Software_Datev"".""SESSION"" = 0x" & sCombitSessionGuid & " AND ( (Buchgkonto = '4150') or (Buchgkonto = '8150') ) and Ust_Satz <> '0.00' "
	if oRecordSet.SetFilter(sFilter) then
		if oRecordSet.RecCount > 0 then
		  		ShowMessage("04.08 Check auf Datev-Autokonten 4150 bzw 8150 Ust <> 0%" &vblf &vblf  &"Beim Datev Export wurden Datenstze mit dem Buchgkonto 4150 oder 8150 mit oder Umsatzsteuer <> 0 % exportiert. " &vblf &vblf & "Dies ist nicht mglich, die Funktion wird beendet. " &vblf &vblf &"Es wird versucht, die Belege anzuzeigen."  &vblf &vblf & "berprfen Sie das Buchgkonto bzw. die Ust. bei den entsprechenden Datenstzen und starten Sie den Datev-Export erneut.")
		    sFilter = "Select Recordid from Factura_Belege where Factura_Belege.Vorgangnr in ( Select Vorgangnr from Factura_Software_Datev where [SESSION]=0x" & sCombitSessionGuid & " AND ( (Buchgkonto = '4150') or (Buchgkonto = '8150') ) and Ust_Satz <> '0.00'   )"
		 'CopyToClipboard(sFilter)
		    ActivateOpenViewSetFilterDirectSQL sFakturaBelege,sFilter
		    'Eintrge lschen wenn wir im Debugmodus sind
		    if bDebugMode = 1 then Exec_SP "Fs_Datev_DeleteSession", ";", sSessionId End if
		    Wscript.Quit
		End if
	End if

'--------------------------------------------------------------------------------------------------------------
'04.09 Check auf Automatikkonto 4315 bzw 8315 Ust 19 %
'--------------------------------------------------------------------------------------------------------------
sFilter = """Factura_Software_Datev"".""SESSION"" = 0x" & sCombitSessionGuid & " AND ( (Buchgkonto = '4315') or (Buchgkonto = '8315') ) and Ust_Satz <> '19.00' "
	if oRecordSet.SetFilter(sFilter) then
		if oRecordSet.RecCount > 0 then
		  		ShowMessage("04.09 Check auf Datev-Autokonten 4315 bzw 8315 Ust <> 19%" &vblf &vblf  &"Beim Datev Export wurden Datenstze mit dem Buchgkonto 4315 oder 8315 mit oder Umsatzsteuer <> 19 % exportiert. " &vblf &vblf & "Dies ist nicht mglich, die Funktion wird beendet. " &vblf &vblf &"Es wird versucht, die Belege anzuzeigen."  &vblf &vblf & "berprfen Sie das Buchgkonto bzw. die Ust. bei den entsprechenden Datenstzen und starten Sie den Datev-Export erneut.")
		    sFilter = "Select Recordid from Factura_Belege where Factura_Belege.Vorgangnr in ( Select Vorgangnr from Factura_Software_Datev where [SESSION]=0x" & sCombitSessionGuid & " AND ( (Buchgkonto = '4315') or (Buchgkonto = '8315') ) and Ust_Satz <> '19.00'   )"
		 'CopyToClipboard(sFilter)
		    ActivateOpenViewSetFilterDirectSQL sFakturaBelege,sFilter
		    'Eintrge lschen wenn wir im Debugmodus sind
		    if bDebugMode = 1 then Exec_SP "Fs_Datev_DeleteSession", ";", sSessionId End if
		    Wscript.Quit
		End if
	End if

'--------------------------------------------------------------------------------------------------------------
'04.10 Check auf Automatikkonto 4125 bzw 8125 Ust 19 %
'--------------------------------------------------------------------------------------------------------------
sFilter = """Factura_Software_Datev"".""SESSION"" = 0x" & sCombitSessionGuid & " AND ( (Buchgkonto = '4125') or (Buchgkonto = '8125') ) and Ust_Satz <> '0.00' "
	if oRecordSet.SetFilter(sFilter) then
		if oRecordSet.RecCount > 0 then
		  		ShowMessage("04.10 Check auf Datev-Autokonten 4125 bzw 8125 Ust <> 19%" &vblf &vblf  &"Beim Datev Export wurden Datenstze mit dem Buchgkonto 4125 oder 8125 mit oder Umsatzsteuer <> 0 % exportiert. " &vblf &vblf & "Dies ist nicht mglich, die Funktion wird beendet. " &vblf &vblf &"Es wird versucht, die Belege anzuzeigen."  &vblf &vblf & "berprfen Sie das Buchgkonto bzw. die Ust. bei den entsprechenden Datenstzen und starten Sie den Datev-Export erneut.")
		    sFilter = "Select Recordid from Factura_Belege where Factura_Belege.Vorgangnr in ( Select Vorgangnr from Factura_Software_Datev where [SESSION]=0x" & sCombitSessionGuid & " AND ( (Buchgkonto = '4125') or (Buchgkonto = '8125') ) and Ust_Satz <> '0.00'   )"
		 'CopyToClipboard(sFilter)
		    ActivateOpenViewSetFilterDirectSQL sFakturaBelege,sFilter
		    'Eintrge lschen wenn wir im Debugmodus sind
		    if bDebugMode = 1 then Exec_SP "Fs_Datev_DeleteSession", ";", sSessionId End if
		    Wscript.Quit
		End if
	End if

'--------------------------------------------------------------------------------------------------------------
'04.11 Check auf Automatikkonto 4120 bzw 8120 Ust 19 %
'--------------------------------------------------------------------------------------------------------------
sFilter = """Factura_Software_Datev"".""SESSION"" = 0x" & sCombitSessionGuid & " AND ( (Buchgkonto = '4120') or (Buchgkonto = '8120') ) and Ust_Satz <> '0.00' "
	if oRecordSet.SetFilter(sFilter) then
		if oRecordSet.RecCount > 0 then
		  		ShowMessage("04.11 Check auf Datev-Autokonten 4120 bzw 8120 Ust <> 19%" &vblf &vblf  &"Beim Datev Export wurden Datenstze mit dem Buchgkonto 4120 oder 8120 mit oder Umsatzsteuer <> 0 % exportiert. " &vblf &vblf & "Dies ist nicht mglich, die Funktion wird beendet. " &vblf &vblf &"Es wird versucht, die Belege anzuzeigen."  &vblf &vblf & "berprfen Sie das Buchgkonto bzw. die Ust. bei den entsprechenden Datenstzen und starten Sie den Datev-Export erneut.")
		    sFilter = "Select Recordid from Factura_Belege where Factura_Belege.Vorgangnr in ( Select Vorgangnr from Factura_Software_Datev where [SESSION]=0x" & sCombitSessionGuid & " AND ( (Buchgkonto = '4120') or (Buchgkonto = '8120') ) and Ust_Satz <> '0.00'   )"
		 'CopyToClipboard(sFilter)
		    ActivateOpenViewSetFilterDirectSQL sFakturaBelege,sFilter
		    'Eintrge lschen wenn wir im Debugmodus sind
		    if bDebugMode = 1 then Exec_SP "Fs_Datev_DeleteSession", ";", sSessionId End if
		    Wscript.Quit
		End if
	End if

'--------------------------------------------------------------------------------------------------------------
'04.12 Check auf Automatikkonto 4315 bzw 8315
'--------------------------------------------------------------------------------------------------------------
sFilter = """Factura_Software_Datev"".""SESSION"" = 0x" & sCombitSessionGuid & " AND ( (Buchgkonto = '4315') or (Buchgkonto = '8315') ) and UstID is NULL "
	if oRecordSet.SetFilter(sFilter) then
		if oRecordSet.RecCount > 0 then
		  		ShowMessage("04.11 Check auf Datev-Autokonten 4315 bzw 8315 Ust auf vorhandene Umsatzsteuer-ID" &vblf &vblf  &"Beim Datev Export wurden Datenstze mit dem Buchgkonto 4315 oder 8315 ohne Umsatzsteuer-ID exportiert. " &vblf &vblf & "Dies ist nicht mglich, die Funktion wird beendet. " &vblf &vblf &"Es wird versucht, die Belege anzuzeigen."  &vblf &vblf & "berprfen Sie das Buchgkonto bzw. die Umsatzsteuer-ID bei den entsprechenden Datenstzen und starten Sie den Datev-Export erneut.")
		    sFilter = "Select Recordid from Factura_Belege where Factura_Belege.Vorgangnr in ( Select Vorgangnr from Factura_Software_Datev where [SESSION]=0x" & sCombitSessionGuid & " AND ( (Buchgkonto = '4315') or (Buchgkonto = '8315') ) and UstID is NULL   )"
		 'CopyToClipboard(sFilter)
		    ActivateOpenViewSetFilterDirectSQL sFakturaBelege,sFilter
		    'Eintrge lschen wenn wir im Debugmodus sind
		    if bDebugMode = 1 then Exec_SP "Fs_Datev_DeleteSession", ";", sSessionId End if
		    Wscript.Quit
		End if
	End if

'--------------------------------------------------------------------------------------------------------------
'04.13 Check auf leere Streams
'--------------------------------------------------------------------------------------------------------------
sFilter = "(""Factura_Software_Datev"".""Stream"" IS NULL OR LEN(RTRIM(""Factura_Software_Datev"".""Stream"")) = 0)"
	if oRecordSet.SetFilter(sFilter) then
		if oRecordSet.RecCount > 0 then
		  		ShowMessage("04.13 Check auf leere Streams" &vblf &vblf  &"Beim Datev Export wurde ein unvorhersebarer Abbruch bei einem Datensatz erzeugt. " &vblf &vblf & "Die Funktion wird beendet. " &vblf &vblf &"Es wird versucht, die Datensatz anzuzeigen."  &vblf &vblf & "berprfen Sie den Datensatz im Beleg und in den Belegpositionan auf Vollstndigkeit und starten Sie den Datev-Export erneut.")
		    sFilter = "Select Recordid from Factura_Belege where Factura_Belege.Vorgangnr in ( Select Vorgangnr from Factura_Software_Datev where  Stream IS NULL    )"
		 'CopyToClipboard(sFilter)
		    ActivateOpenViewSetFilterDirectSQL sFakturaBelege,sFilter
		    'Eintrge lschen wenn wir im Debugmodus sind
		    if bDebugMode = 1 then Exec_SP "Fs_Datev_DeleteSession", ";", sSessionId End if
		    Wscript.Quit
		End if
	End if



sFilter	= """Factura_Software_Datev"".""SESSION"" = 0x" & sCombitSessionGuid

if not oRecordSet.SetFilter(sFilter) then 
  ShowMesseage("047: unerwarteter Abbruch.")	
   'Eintrge lschen wenn wir im Debugmodus sind
    if bDebugMode = 1 then Exec_SP "Fs_Datev_DeleteSession", ";", sSessionId End if
    Wscript.Quit
End If

End if

'--------------------------------------------------------------------------------------------------------------
'05 Erstellen der Einmaligen Datev Objekte
'--------------------------------------------------------------------------------------------------------------
'Run Datev Schnittstelle 
Dim objExt, bRet, objDatev

	' fehlende DLL abfangen
  	On Error Resume Next
  	Set objExt = CreateObject("cosmolinkCRMExt.application")
  	If ((objExt Is Nothing) OR (Err.Number <> 0)) Then
  	 	Msgbox("Diese Funktion seht nach Freischaltung von cosmolink faktura zur Verfgung. Der Vorgang wird beendet.")
   		WScript.Quit
  	End If
	On Error GoTo 0
  	' / fehlende DLL abfangen
    
	'MsgBox "Starte bRet"
	bRet = objExt.DatevExportSetup(sDatevOrdner, true, sBeraterNummer, sBeraterName, sMandatnr, Cint(iSKLenDaten), Cint(iSKLenStammdaten))
	'MsgBox "Starte Export"
	Set objDatev = objExt.DatevExport(Cint(iAbrechnungsNummer), sDatevVon, sDatevBis) 
	'MsgBox "Starte Export1"




'--------------------------------------------------------------------------------------------------------------
' 06 Properties fr Buchungen - Schleife auf die Datenstze
'--------------------------------------------------------------------------------------------------------------
Dim sStream,sTrennzeichen,sArray,iCounter,sText

Dim v0,v1,v2,v3,v4,v5,v6,v7,v8,v9,v10,v11,v12,v13,v14,v15,v16,v17,v18,v19,v20,v21,v22,v23,v24,v25,v26,v27,v28,v29

Dim sKonto, sGegenkonto, iBetrag, sDatum, sWKZ, sSteuerschluessel, sBerichtungsschluessel, sBuchungstext, sBelegfeld1, sBelegfeld2, sKoSt1, sKoSt2, sKoStMenge, sSkonto, sEULand, sUstID, sEUSteuersatz, sBasisBetrag, sBasisWKZ, sKurs
Dim sGegenkontoImBelge 'NEU 23.05.2011 
Dim sPlz, sOrt, sStrasse, sAnrede, sName2, sName1, sFirmaRecord
Dim sBank, sBankKtnr, sBankBlz

Dim sZahlziel,sZahldatum, sUstSatz, sAnredeText, sVorname, sName

If oRecordSet.MoveFirst Then ' Datenstze vorhanden
  
  sTrennzeichen = "#|#" 
  
  ' ------------------------------------------------
   ' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
   'Wichtig: Sortierung der Datenstze an oder aus?
   oRecordSet.SortOrder(0) 
   ' ------------------------------------------------
   
  Do  ' Loop Datenstze
   
   sStream = ""
  
   Set oRecord = oRecordSet.CurrentRecordSynchronized
   
   sStream = oRecord.GetContentsByName("Stream")
  
   'ShowMessage(sStream)

  
   If sStream <> "" Then ' Stream auflsen
   
     sArray = Split(sStream, sTrennzeichen)

	sText = ""

	For iCounter = 0 To UBound(sArray)
  		sText = sText & sArray(iCounter) & vbCr & vbLf  
	Next
    
    v0 = sArray(0) 
  
	  'If(v0=" ") Then 
	  '	showmessage("v0")
	  	'WScript.Quit
	  'End If
	  
	  v1 = sArray(1)
	  v2 = sArray(2)
	  v3 = sArray(3)
	  v4 = sArray(4)
	  v5 = sArray(5)
	  v6 = sArray(6)
	  v7 = sArray(7)
	  v8 = sArray(8)
	  v9 = sArray(9)
	  v11 = sArray(11)
	  v12 = sArray(12)
	  v13 = sArray(13)
	  v14 = sArray(14)
	  v15 = sArray(15)
	  v16 = sArray(16)
	  v17 = sArray(17)
	  v18 = sArray(18)
	  v19 = sArray(19)
	  v20 = sArray(20)
	  v21 = sArray(21)
	  v22 = sArray(22)
	  v23 = sArray(23)
	  v24 = sArray(24)
	  v25 = sArray(25)
	  v26 = sArray(26)
	  v27 = sArray(27)
	  v28 = sArray(28)
	  v29 = sArray(29)

		sKonto				=	Mid(CStr(RegExpTest("[0123456789]", v0)),1,9)
		sGegenkonto			=	Mid(CStr(RegExpTest("[0123456789]", v1)) ,1,9)
		sGegenkontoImBelge		= 	Mid(CStr(RegExpTest("[0123456789]", v1) ),1,9)
		iBetrag				=	GetDatevBetrag(v20)
		sDatum				=	v2
		sWKZ					=	v3
		sSteuerschluessel		=	""
		sBerichtungsschluessel		=	v4
		sBuchungstext			=	Mid(CStr(v5),1,30)
		sBelegfeld1				=	Mid(CStr(v6),1,12) 'Belegnr
		
		'xxx
		if bEinnahmeueberschuss <> "true" then
			sBelegfeld2				=	Mid(CStr(v7),1,12) 'Zahlziel 
		Else
			sBelegfeld2				=	Mid(CStr(v8),1,12)  'Zahdatum 
		End if				
		
		sKoSt1				=	Mid(CStr(v11),1,8) 
		sKoSt2				=	Mid(CStr(v12),1,8) 
		sKoStMenge			=	GetDatevBetrag(v13)
		sSkonto				=	GetDatevBetrag(v14)
	
		sEULand				=	v15
		
		if sEULand <> "" and len(sEULand) >=1 and len(sEULand) <=2 then
			sEULand = GetIsoCodeLand (sEULand)		
			sEULand = Cstr(sEULand) 
		End If

		sUstID				=	v9
		sEUSteuersatz			=	GetDatevBetrag(v16)
		sBasisBetrag			=	""
		sBasisWKZ				=	""
		sKurs					=	""
		sZahlziel				= 	v17
		sZahldatum				=	v18
		sUstSatz				= 	v19
		
		sPlz					=	Mid(CStr(v21),1,5)
		sOrt					=	Mid(CStr(v22),1,20) 
		sStrasse				=	Mid(CStr(v23),1,20) 
		
		sAnrede				=	v24
		sAnredeText			=	v25
		
		if sAnrede <> "1" then
			if (InStr(" Frau",sAnredeText))  > 0 then
			    sAnrede =  "3"	'Frau
			Else
			  sAnrede =  "2"	'Herr
			End if
		End if
		
		
		sVorname				= 	v26
		sName				= 	v27
		sName2				=	v27
		sName1				=	""
		sFirmaRecord			=	v28


sText		="sKonto				=	" &sKonto 			&vblf _
		&" sGegenkonto			=	" &sGegenkonto		&vblf _
		&"sGegenkontoImBelge		= 	" &sGegenkontoImBelge	&vblf _
		&"iBetrag				=	" &iBetrag			&vblf _
		&"sDatum				=	" &sDatum			&vblf _
		&"sWKZ				=	" &v3				&vblf _
		&"sSteuerschluessel		=	" &""				&vblf _
		&"sBerichtungsschluessel	=	" &v4				&vblf _
		&"sBuchungstext			=	" &sBuchungstext		&vblf _
		&"sBelegfeld1			=	" &v6 	&vblf _
		&"sBelegfeld2			=	" &v7 	&vblf _
		&"sKoSt1				=	" &v11	&vblf _
		&"sKoSt2				=	" &v12	&vblf _
		&"sKoStMenge			=	" &v13	&vblf _
		&"sSkonto				=	" &v14	&vblf _
		&"sEULand				=	" &v15	&vblf _
		&"sUstID				=	" &v9		&vblf _
		&"sEUSteuersatz			=	" &v16	&vblf _
		&"sBasisBetrag			=	" &""		&vblf _
		&"sBasisWKZ			=	" &""		&vblf _
		&"sKurs				=	" &""		&vblf _
		&"sZahlziel				= 	" &v17	&vblf _
		&"sZahldatum			=	" &v18	&vblf _
		&"sUstSatz				= 	" &v19	&vblf _
		&"sPlz				=	" &v21	&vblf _
		&"sOrt				=	" &v22	&vblf _
		&"sStrasse				=	" &v23	&vblf _
		&"sAnrede				=	" &v24	&vblf _
		&"sAnredeText			=	" &v25	&vblf _
		&"sVorname			= 	" &v26	&vblf _
		&"sName				= 	" &v27	&vbLf _
		&"sName2				=	" &v27	&vblf _
		&"sName1				=	" &""		&vblf _	
		&"sFirmaRecord			=	" &v28	&vblf _
		&"Vorgang				=	" &v10	&vblf 


		'sText = "huhu"
		'ShowMessage(sText)


	'--------------------------------------------------------------------------------------------------------------
	'07 Buchen in der Schleife
	'--------------------------------------------------------------------------------------------------------------
	objDatev.Konto 			= sKonto
	objDatev.GegenKonto 		= Cstr(sGegenkonto)
	objDatev.Betrag 			= iBetrag
	objDatev.Datum 			= sDatum
	
	if (sWKZ <> " ") and len (sWKZ)>0 then
		objDatev.WKZ 			= sWKZ
	End if

	if (sSteuerschluessel <> " ") and len (sSteuerschluessel)>0 then
		objDatev.Steuerschluessel	= sSteuerschluessel
	End if

	if (sBerichtungsschluessel <> " ") and len (sBerichtungsschluessel)>0 then
		objDatev.Berichtungsschluessel	= sBerichtungsschluessel
	End if

	if (sBuchungstext <> " ") and len (sBuchungstext)>0 then
		objDatev.Buchungstext	= sBuchungstext
	End if

	if (sBelegfeld1 <> " ") and len (sBelegfeld1)>0 then
		objDatev.Belegfeld1	= sBelegfeld1
	End if

	if (sBelegfeld2 <> " ") and len (sBelegfeld2)>0 then
		objDatev.Belegfeld2	= sBelegfeld2
	End if

	if (sKoSt1 <> " ") and len (sKoSt1)>0 then
		objDatev.KoSt1	= sKoSt1
	End if

	if (sKoSt2 <> " ") and len (sKoSt2)>0 then
		objDatev.KoSt2	= sKoSt2
	End if	
	
	if (sKoStMenge <> " ") and sKoStMenge>0 then
		objDatev.KoStMenge	= sKoStMenge
	End If

	if (sSkonto <> " ") and sSkonto>0 then
		objDatev.Skonto	= sSkonto
	End if

	if (sEULand <> " ") and  len (sEULand)>0 And (sEULand <> "DE") Then 'Change Version 002 (16.02.2012)
		objDatev.EULand	= sEULand
	End If

	if (sUstID <> " ") and  len(sUstID) >=2  Then
		sUstID = EntferneSonderzeichen(sUstID)
		sUstID = StringReplace(sUstID, sEULand, "")
		sUstID = StringReplace(sUstID, " ", "")
		sUstID = StringReplace(sUstID, "AT", "")
		sUstID = Mid(CStr(sUstID),1,13) 
		objDatev.UstID	= sUstID
	End If
	
	if (sEUSteuersatz <> " ") and sEUSteuersatz>0 then
		objDatev.EUSteuersatz	= sEUSteuersatz
	End if
	
	
	bRet = objDatev.Buchung() 
	
	
	Dim sVoherigerBeleg, SLDebitor 'SL steht fr StringListe
	
	'Debitoren
	if sVoherigerBeleg <> sBelegfeld1 then 'neuer Beleg
	
		  'xxxx
	  sName1    = Mid(CStr(v5),1,20)
	  sName1	= EntferneSonderzeichen(sName1)
	  if sName1 = ""  or len(sName1) <=2 then
			sName1 = "P" 'Wenn keine Firma drin steht soll er P fr Person reinschreiben.
		'ShowMessage(sAnrede)
	  End If
	
	  if instr(SLDebitor ,"#|#" & sKonto &"#|#") > 0 Then ' Debitor neu Anlegen
     		 'ShowMessage("Debitor: " & sKonto & "  " & sBuchungstext &" schon vorhanden und braucht nicht neu angelet zu werden..." )
		 'Do nothing
 	  Else
		'Debitor in DatevSchnittstelle Schreiben
		'ShowMessage(sKonto)
		'Call cRM.EndWaitDlg()
		If IstZahl(sKonto) Then
			if sKonto <10000 then
			  sKonto = CStr(CInt(sKonto)+10000)
			End if
		Else
		  sKonto = RegExpTest("[0123456789]", sKonto)
		  ShowMessage( "Datensatz "&vblf & "Konto " & sKonto &vblf & " Name1" & sName1 &vblf & "Plz" & sPlz &vblf & "Ort " & sOrt &vblf   & "Strasse " & sStrasse &vblf   & " sAnrede" & sAnrede  &vblf & " Name2" & sName2 &vblf  & " Konto wurde auf " & sKonto &" gesetzt. " &vblf & "Erstelen Sie aus " & sKonto &" eine Zahl, damit die Datev-Schnittstelle sauber durchluft.")
		  if (sKonto = "") or (sKonto = " ") then
		    sKonto = "10000"
		  End if
		End if
		
		'ShowMessage("sKonto" & sKonto &vblf & "sName1" & sName1 &vblf & "sPlz" & sPlz &vblf & "sOrt" & sOrt &vblf   & "sStrasse" & sStrasse &vblf   & "sAnrede" & sAnrede  &vblf & "sName2" & sName2 &vblf  )
		bRet = objDatev.DebitorStart(true, sKonto, sName1)  ' 102,103
		bRet = objDatev.DebitorDaten("104", sKonto) 					'Kundennummer
	  	
		if sPlz <> " " and len(sPlz) >=1 and len(sPlz) <=5 then
			bRet = objDatev.DebitorDaten("106", sPlz) 
		End if

		if sOrt <> " " and len(sOrt) >=2 and len(sOrt) <=20 then
			bRet = objDatev.DebitorDaten("107", sOrt) 
		End if
		
		if sStrasse <> " " and len(sStrasse) >=2 and len(sStrasse) <=20 then
			bRet = objDatev.DebitorDaten("108", sStrasse) 
		End if

		if (sAnrede <> " ") and (sAnrede <> "") and (IstZahl(sAnrede))   then
		'if (sAnrede = "1") then
			'ShowMessage(sAnrede)
			bRet = objDatev.DebitorDaten("109", sAnrede)
		End if

		sName2	= EntferneSonderzeichen(sName2)
		
		if sName2 <> " " and len(sName2) >=1 and len(sName2) <=20 then
			bRet = objDatev.DebitorDaten("203", sName2) 
		End if

	  End if	

	SLDebitor = SLDebitor &"#|#" & sKonto &"#|#"

	End if
	
	sVoherigerBeleg = sBelegfeld1

	

   	'bRet = objDatev.ExportFinish(true)
   End If ' / Stream auflsen 
  
  
  Loop Until Not oRecordSet.MoveNext '/ Loop Datenstze
  

Else 
  Showmessage("Keine Datenstze gefunden. Der Datev-Export wird beendet.")
  Set oRecord 	 = Nothing
  Set oRecordSet = Nothing
  Set oView 	 = Nothing
  WScript.Quit
End If ' / Datenstze vorhanden 


  Set oRecord 	 = Nothing
  Set oRecordSet  = Nothing
  Set oView 	 = Nothing
  
  'ShowMessage("Ja er lebt noch")
  bRet = objDatev.ExportFinish(true)

  Set objDatev = Nothing
  Set objExt = Nothing


'--------------------------------------------------------------------------------------------------------------
'08 Erfolgsmeldung
'--------------------------------------------------------------------------------------------------------------
 If ShowQuestion ("Die Daten fr den Steuerberater wurden erfolgreich erstellt." &vblf &vblf & "Sie befinden sich im Ordner: " & sDatevOrdner &vblf &vblf &"Soll der Datev-Ordner geffnet werden?") Then
  Dim shell, expl
  set shell = WScript.CreateObject("WScript.Shell") 
  set expl = shell.exec("explorer.exe " &sDatevOrdner)
End if

If not ShowQuestion ("Mchten Sie den Verlauf des Datev-Exports Protokollieren?" &vblf &vblf )Then
   Exec_SP "Fs_Datev_DeleteSession", ";", sSessionId 
End if
 
'-------------------------------------------------------------------------------------------------------------
' 09. Funktionen
'--------------------------------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------------
' 09.01 ReadIniFile(Dateiname,Sektion, Eintrag) Liest aus einer Ini-Datei einen Parameter aus
'--------------------------------------------------------------------------------------------------------------
Function ReadIniFile(Dateiname,Sektion, Eintrag)
	' Variablen deklarieren
	Dim FSO, IniDatei, Zeile, EintragWert, Zeichen
	Dim EintragGefunden,  SektionGefunden
	Dim I
	' Konstanten definieren
	Const ForReading = 1
	
	Set FSO = CreateObject("Scripting.FileSystemObject")
	' Ini-Datei zum Lesen ffnen
	Set IniDatei = FSO.OpenTextFile(Dateiname, ForReading)
	' Durchlaufe die gesamte Datei
	Do While Not IniDatei.AtEndOfStream
	  Zeile=IniDatei.readline
	  ' Wenn die aktuielle Zeile eine Sektion kennzeichnet
	    If Left(Zeile,1)="[" Then
	      ' Ist es die gesuchte Sektion?
	      If UCase(Mid(Zeile,2,Len(Sektion)))=UCase(Sektion) Then
		' Ja
		SektionGefunden=True
	      Else
		' Nein
		SektionGefunden=False
	      End If
	    Else
	      If SektionGefunden Then
		'Ist die aktuelle Zeile der gesuchte Eintrag
		 If UCase(Left(Zeile,Len(Eintrag)))=UCase(Eintrag) Then
		   I = Len(Eintrag)+1
		   ' Solange wiederholen bis der Eintrag gefunden wurde
		   Do While I<Len(Zeile)
		     Zeichen = Mid(Zeile,I,1)
		     ' Suche das Gleichheitszeichen
		     If Zeichen="=" Then
		       ' Ermitteln des Wertes
		       EintragWert=Right(Zeile,Len(Zeile)-I)
		       ' Abbruchbedinung setzen
		       I=Len(Zeile)
		       EintragGefunden=True
		     Else
		       I=I+1
		     End If
		   Loop							
		 End If
	       End If		
	     End If
	Loop
	' Datei schliessen
	IniDatei.close
	' Wert zurckgeben
	ReadIniFile = Trim(EintragWert)
End Function



'-------------------------------------------------------------------------------------------------------------
' 09.02 Exec_SP (Ausfhren einer SP)
'--------------------------------------------------------------------------------------------------------------
Function Exec_SP(sProcedure, sSPTrennzeichen, sParameter)

	' Dim sProcedure, sTrennzeichen, sParameter

	 
	 'sParameter = sArtikelnr & ";" & sErfuser & ";" & sLager & ";" & iMenge
	 
	 Exec_SP = (StoredProcedure( sProcedure,sSPTrennzeichen,sParameter))
   
	   if Exec_SP = false THEN
		ShowMessage("Die Prozedure " & sProcedure &" wurde nicht korrekt durchgefhrt. " &vblf & vblf &"Parameter: " &sParameter) 
		Wscript.Quit
	   End If

End Function	   


'-------------------------------------------------------------------------------------------------------------
' 09.03 GetGuid() gennerieren einer GUID
'--------------------------------------------------------------------------------------------------------------
Function GetGuid()
  Dim TypeLib
    Set TypeLib = CreateObject("Scriptlet.TypeLib")
    GetGuid = Left(CStr(TypeLib.Guid), 38)
    GetGuid = Replace(GetGuid,"{","")
    GetGuid = Replace(GetGuid,"}","")
    
    Set TypeLib = Nothing
End Function


'-------------------------------------------------------------------------------------------------------------
' 09.04 GetCombitGuid (sFormattedGUID) wandeln von 09.03 ins combit Ansichten Format
'--------------------------------------------------------------------------------------------------------------
Function GetCombitGuid (sFormattedGUID)
	GetCombitGuid = LCase(Mid(sFormattedGUID, 7, 2) 	_
					 & Mid(sFormattedGUID, 5, 2)  _
					 & Mid(sFormattedGUID, 3, 2)  _ 
					 & Mid(sFormattedGUID, 1, 2)  _ 
					 & Mid(sFormattedGUID, 12, 2)  _ 
					 & Mid(sFormattedGUID, 10, 2)  _ 
					 & Mid(sFormattedGUID, 17, 2)  _ 
					 & Mid(sFormattedGUID, 15, 2)  _ 
					 & Mid(sFormattedGUID, 20, 4)  _ 
					 & Mid(sFormattedGUID, 25, 12))
End Function 



'-------------------------------------------------------------------------------------------------------------
' 09.05 Funktion ob ein Land ein EU Land ist
'--------------------------------------------------------------------------------------------------------------
Function IstEuLand (sLand)

IstEuLand = False

	if sLand <> "" then
		Select Case sLand
			Case "BE" 
				IstEuLand = true
			Case "BG" 
				IstEuLand = true
			Case "DG"
				IstEuLand = true
			Case "DK"
				IstEuLand = true
			Case "EE" 
				IstEuLand = true
			Case "FI" 
				IstEuLand = true
			Case "FR" 
				IstEuLand = true
			Case "GR" 
				IstEuLand = true
			Case "IE" 
				IstEuLand = true
			Case "IT" 
				IstEuLand = true
			Case "LV" 
				IstEuLand = true
			Case "LT" 
				IstEuLand = true
			Case "LU" 
				IstEuLand = true
			Case "MT" 
				IstEuLand = true
			Case "NL" 
				IstEuLand = true
			Case "AT" 
				IstEuLand = true
			Case "PL"
				IstEuLand = true
			Case "PT"
				IstEuLand = true
			Case "RO"
				IstEuLand = true
			Case "SE"
				IstEuLand = true
			Case "SK"
				IstEuLand = true
			Case "SL"
				IstEuLand = true
			Case "ES"
				IstEuLand = true
			Case "CZ"
				IstEuLand = true
			Case "HU"
				IstEuLand = true
			Case "CY"
				IstEuLand = true

		End Select
	Else
	IstEuLand = false
	End if

End Function

'-------------------------------------------------------------------------------------------------------------
' 09.06 GetIsoCodeLand (sLand) Rckgabe cmbt Iso-Code
'--------------------------------------------------------------------------------------------------------------
Function GetIsoCodeLand (sLand)

	Select Case sLand
			Case "I" 
				sLand = "IT"
			Case "" 
				sLand = "DE"
			Case "D" 
				sLand = "DE"
			Case "S" 
				sLand = "SE"
			Case "FIN" 
				sLand = "FI"
			Case "FIN" 
				sLand = "FI"
			Case "IRL" 
				sLand = "IE"
			Case "P" 
				sLand = "PT"
			Case "H" 
				sLand = "HU"
			Case "SLO" 
				sLand = "SI"
			Case "M" 
				sLand = "MT"
			Case "SLO" 
				sLand = "SI"
			Case "A" 
				sLand = "AT"
			Case "L" 
				sLand = "LU"
			Case "E" 
				sLand = "ES"
			Case "B" 
				sLand = "BE"
			Case "A" 
				sLand = "AT"	



		End Select
	GetIsoCodeLand  = sLand

 
End Function

'-------------------------------------------------------------------------------------------------------------
' 09.07 RegExpTest Regulre Ausdrcke fr einen String
'--------------------------------------------------------------------------------------------------------------
Function RegExpTest(patrn, strng)
    Dim regEx, Match, Matches, s
    Dim sNummer
    ' Create the regular expression.
    Set regEx = New RegExp
    regEx.Pattern = patrn
    regEx.IgnoreCase = True
    regEx.Global = True

    ' Do the search.
    Set Matches = regEx.Execute(strng)

    ' Iterate through the Matches collection.
    s = ""
    For Each Match in Matches
    '  s = s & "Match found at position "
    '  s = s & Match.FirstIndex & ". "
    '  s = s & "Match Value is '"
      s = s & Match.Value 
    '  s = s & vbCRLF
    Next

    RegExpTest = s
End Function



'-------------------------------------------------------------------------------------------------------------
' 09.08 EntferneSonderzeichen(sString) aus einem String
'--------------------------------------------------------------------------------------------------------------
Function EntferneSonderzeichen(sString)

EntferneSonderzeichen		= StringReplace(sString, "|"," ")
EntferneSonderzeichen		= StringReplace(EntferneSonderzeichen, "~"," ")
EntferneSonderzeichen		= StringReplace(EntferneSonderzeichen, "'","")
EntferneSonderzeichen		= StringReplace(EntferneSonderzeichen, ""," ")
EntferneSonderzeichen		= StringReplace(EntferneSonderzeichen, "?"," ")
EntferneSonderzeichen		= StringReplace(EntferneSonderzeichen, "","e")
EntferneSonderzeichen		= StringReplace(EntferneSonderzeichen, ","," ")
EntferneSonderzeichen		= StringReplace(EntferneSonderzeichen, "     "," ")
EntferneSonderzeichen		= StringReplace(EntferneSonderzeichen, "    "," ")
EntferneSonderzeichen		= StringReplace(EntferneSonderzeichen, "   "," ")
EntferneSonderzeichen		= StringReplace(EntferneSonderzeichen, "  "," ")

End Function



'-------------------------------------------------------------------------------------------------------------
' 09.09 fieldGetDouble DatevBetrags Format
'--------------------------------------------------------------------------------------------------------------
Function GetDatevBetrag(varFieldName)
	If VarType(varFieldName) = 8 Then ' 8 => vbString
		If (len(varFieldName)>0) and (varFieldName<>" ")  then
			'ShowMessage(varFieldName)
			GetDatevBetrag = CDbl(Replace((CStr(varFieldName)), ".", ","))
		Else
			GetDatevBetrag = 0
		End if
	ElseIf IsNumeric(varFieldName) Then
		fieldGetDouble = CDbl(Replace(varFieldName, ".", ","))
	Else
		err.Raise 20000, "Funktion GetDatevBetrag", "String oder Zahl erwartet."
	End IF
End Function
