'--------------------------------------------------------------------------------------------------------------
' Faktura-Software Scriptdatei 
' Funktion: 	Firma zum Beleg auswhlen
' Ansicht:  	FakturaBelege
' Script:	FakturaBelege_62_Firma_auswaehlen.vbs
' Produkt:	combit Relationship Manager 6
' Autor  :  	Andreas Mller

' Faktura-Software.net macht keine Angaben zu einer bestimmten Eignung der Information in diesem Script
' Irrtmer und Fehler bleiben ausdrcklich vorbehalten und die Angaben erfolgen ohne Gewhr. 
' Die Angaben stellen nur Einzelfallszenarien dar und enthalten keine Garantie der Beschaffenheit 
' der Produkte. 
 
' Copyright (c) by Faktura-Software.net. Alle Rechte vorbehalten.
'--------------------------------------------------------------------------------------------------------------

Option Explicit

<!--#include file="%PRJDIR%\script\CosmoOle.vbs"-->



'--------------------------------------------------------------------------------------------------------------
' Begin Versionierung
'--------------------------------------------------------------------------------------------------------------
Dim sSkriptVersion
sSkriptVersion = "002"
'--------------------------------------------------------------------------------------------------------------
' What's new
'--------------------------------------------------------------------------------------------------------------
' Version 002 
' - Modul Adressen integriert
'--------------------------------------------------------------------------------------------------------------

Dim sErrorCode, sErrorProjekt, sErrorAnsicht, sErrorSkript

sErrorProjekt   = cRM.CurrentProject.GetSessionProperty("cRM_Projekt_ProjektNr",True)
sErrorAnsicht   = "118"
sErrorSkript    = "062"

sErrorCode =  sErrorProjekt & sErrorAnsicht & sErrorSkript

'--------------------------------------------------------------------------------------------------------------
' Ende Versionierung
'--------------------------------------------------------------------------------------------------------------


'nderungsbenutzer ermitteln

Dim sAend_User

sAend_User = cRM.CurrentProject.CurrentUser

If sAend_User = "" Then
  WScript.Quit
End If

'/ nderungsbenutzer ermitteln


'Beleg ermitteln

Dim sBelegRecordid

sBelegRecordid = cRM.CurrentProject.ActiveViews.ActiveView.CurrentRecordSet.CurrentRecordSynchronized.GetContentsByName("Recordid")
 
If sBelegRecordid = "" Then
  WScript.Quit
End If

'/ Beleg ermitteln

'Firmenvariablen
Dim sFilterFirma,sFirmenRecordid

Dim sProcedure,sTrennzeichen,sParameter,bsp
Dim sAdressID, sLieferAdressID
Dim sTrialDat, sBelegAdresseAktiv, sLieferAdresseAktiv


If Not WScript.RightClicked Then 'Firma auswhlen
  sFirmenRecordid = OpenDialogSelectRecord("Firmen",sFilterFirma,"ID","Firma auswhlen","Keine Firma gefunden. Die Auswahl wird abgebrochen.")
Else
    Dim bHinweis
    bHinweis	= ShowQuestion("Sollen die Adressinformationen aus diesem Beleg entfernt werden?")
    
    If bHinweis Then
    	'Firma entfernen
    	sFirmenRecordid  = "Entfernen"
	ExecSP()
	Wscript.Quit
    End If
End If

'Nur die Firmen in der Auswahl anzeigen, die nicht gesperrt sind
sFilterFirma = """Companies"".""Blocked"" <> 1 or  ""Companies"".""Blocked"" IS  Null"


'sFirmenRecordid = OpenDialogSelectRecord("Firmen",sFilterFirma,"ID","Firma auswhlen","Keine Firma gefunden. Die Auswahl wird abgebrochen.")

If sFirmenRecordid = "" Then
  WScript.Quit
End If

' / Firma auswhlen

'---------------------------------------------------------------------------------------------------------------------
'Modul Faktura_Adressen 
'---------------------------------------------------------------------------------------------------------------------
' Dim sAdressID, sLieferAdressID wurde oben deklariert


'Auslesen, ob FakturaAdressen aktiv ist 
Dim sGlobalFilter,sFakturaAdressenAktiv

sGlobalFilter	= "upper(""Factura_Software_Global"".""FS_Recordid"") = upper(N'FS-Modul03')"
		
sFakturaAdressenAktiv = GetHiddenFieldContentByName("FakturaGlobaleEinstellungen", sGlobalFilter,"Result", "Der Parameter FakturaAdressenAktiv konnte in FakturaGlobaleEinstellungen nicht gefunden werden.")
'ShowMessage(sFakturaAdressenAktiv)
sFakturaAdressenAktiv = SplitStingInArray(sFakturaAdressenAktiv,1)

Dim sModulStatus 
sModulStatus  = sFakturaAdressenAktiv

'ShowMessage(sFakturaAdressenAktiv)
if UCase(Mid(sModulStatus,1,3)) = UCase("tri") then

	On Error Resume Next
		sTrialDat = Right(sFakturaAdressenAktiv,10)
		If (Err.Number <> 0) Then
			Msgbox("Fehler beim Auslesen des Trial Datums" &vbLf  &"Der Vorgang wird ohne das Modul X-Address fortgefhrt.")
			sFakturaAdressenAktiv = "Nein"
	End If
	On Error GoTo 0
End if

if UCase(Mid(sFakturaAdressenAktiv,1,1)) = UCase("t") then
  sFakturaAdressenAktiv = "Ja"
End if


'ShowMessage(sFakturaAdressenAktiv)

If sFakturaAdressenAktiv = "Ja" Then 'Adressauswahl

   'Auslesen der Parameter 
   sGlobalFilter = "upper(""Factura_Software_Global"".""FS_Recordid"") = upper(N'AuswahlBelegEmpf')"
   
   sBelegAdresseAktiv = GetHiddenFieldContentByName("FakturaGlobaleEinstellungen", sGlobalFilter,"Result", "Der Parameter FakturaAdressenAktiv konnte in FakturaGlobaleEinstellungen nicht gefunden werden.")

   sGlobalFilter = "upper(""Factura_Software_Global"".""FS_Recordid"") = upper(N'AuswahlLieferEmpf')"
   
   sLieferAdresseAktiv = GetHiddenFieldContentByName("FakturaGlobaleEinstellungen", sGlobalFilter,"Result", "Der Parameter FakturaAdressenAktiv konnte in FakturaGlobaleEinstellungen nicht gefunden werden.")
  
  Dim sFilterAdresse,sViewAdresse,sFieldAdresse, sErrorAdresse,oView,oRecordSet,bFilter,oCurrentRecord
  
  
  'Auslesen Adresse 1: Belegadresse
  If sBelegAdresseAktiv = "Ja" Then
  
  
  		sViewAdresse   ="FakturaAdressen"
		sFieldAdresse  ="ID"
		sFilterAdresse = " Select a.ID from Factura_Adressen a, Factura_Adressen_Zuordnung z  where " _
			& "		z.CompanyID = 0x" & sFirmenRecordid  _
			&"	and	a.ID = z.AddressID and z.Belegadresse = 1 "

		'ShowMessage (sFilterAdresse)
		sErrorAdresse  ="Keine Belegadresse vorhanden. Der Beleg wird mit der Hauptadresse der Firma befllt."
		
		'sAdressID = OpenDialogSelectRecordDontQuit(sViewAdresse, sFilterAdresse,sFieldAdresse,"Auswahl der Belegadresse", sErrorAdresse)
		
		
		Set oView = cRM.CurrentProject.ViewConfigs.ItemByName(sViewAdresse)
		
		Set oRecordSet = oView.CreateRecordSet
		
		bFilter = oRecordSet.SetFilterDirectSQL(sFilterAdresse)
		
		If bFilter Then 'Filter OK
			If oRecordSet.Reccount > 1 Then
			  'Wenn Trial dann Medlung
			   if ((sLieferAdresseAktiv = "Ja") or  (sBelegAdresseAktiv = "Ja")) and (len(sTrialDat)>3)  then
			      ShowMEssage("Trial gltig bis zum: " &sTrialDat)
			   End if
		

			  Set oCurrentRecord = oRecordSet.DialogSelectRecord("Auswahl der Belegadresse")
			  
			  'Set oCurrentRecord =  oRecordSet.CurrentRecordSynchronized
			  If oCurrentRecord Is Nothing Then  
			   sAdressID = "Null"
			  Else 
			    sAdressID = oCurrentRecord.GetContentsByName(sFieldAdresse)
			  End If
			  
			    
			ElseIf oRecordSet.MoveFirst Then 
			  
			  Set oCurrentRecord =  oRecordSet.CurrentRecordSynchronized
			  
			   sAdressID = oCurrentRecord.GetContentsByName(sFieldAdresse)
			
			Else 
			  sAdressID = "Null"
			  'showmessage(sErrorAdresse)
			End If
		
		Else 'Filter Ok
		  sAdressID = "Null"
		  'showmessage(sErrorAdresse)
		End If ' /Filter OK
		
		
  Else sAdressID = "Null"
  
  End If
  
 'Auslesen Adresse 2: Lieferadresse
 If sLieferAdresseAktiv = "Ja" Then
 
		sViewAdresse   ="FakturaAdressen"
		sFieldAdresse  ="ID"
		sFilterAdresse = " Select a.ID from Factura_Adressen a, Factura_Adressen_Zuordnung z  where " _
			& "		z.CompanyID = 0x" & sFirmenRecordid  _
			& "	and	a.ID = z.AddressID and z.Lieferadresse = 1 "

		sErrorAdresse  ="Keine Lieferadressen vorhanden. Der Beleg wird mit der Lieferadresse der Firma befllt, sofern vorhanden."
		
		'sLieferAdressID = OpenDialogSelectRecordDontQuit(sViewAdresse, sFilterAdresse,sFieldAdresse,"Auswahl der Lieferadresse", sErrorAdresse)
		Set oView = cRM.CurrentProject.ViewConfigs.ItemByName(sViewAdresse)
		
		Set oRecordSet = oView.CreateRecordSet
		
		bFilter = oRecordSet.SetFilterDirectSQL(sFilterAdresse)
		
		If bFilter Then 'Filter OK
			If oRecordSet.Reccount > 1 Then
			
			  Set oCurrentRecord = oRecordSet.DialogSelectRecord("Auswahl der Lieferadresse")
			  
			  'Set oCurrentRecord =  oRecordSet.CurrentRecordSynchronized
			  If oCurrentRecord Is Nothing Then  
			   sLieferAdressID = "Null"
			  Else 
			    sLieferAdressID = oCurrentRecord.GetContentsByName(sFieldAdresse)
			  End If
			  
			    
			ElseIf oRecordSet.MoveFirst Then 
			  
			  Set oCurrentRecord =  oRecordSet.CurrentRecordSynchronized
			  
			   sLieferAdressID = oCurrentRecord.GetContentsByName(sFieldAdresse)
			
			Else 
			  sLieferAdressID = "Null"
			  'showmessage(sErrorAdresse)
			End If
		
		Else 'Filter Ok
		  sLieferAdressID = "Null"
		  'showmessage(sErrorAdresse)
		End If ' /Filter OK
		
		
		
		
  Else sLieferAdressID = "Null"

  
  End If 
  
  
End If ' / Adressauswahl

ExecSP()

'---------------------------------------------------------------------------------------------------------------------
'/ Modul Faktura_Adressen 
'---------------------------------------------------------------------------------------------------------------------



Sub ExecSP()
' ----- 2. Ausfhren der Stored Procedure -----
 '  Dim sProcedure, sTrennzeichen,sParameter
   
   
   ' Stored Procedure ausfhren

	sProcedure = "Fs_Beleg_Firma_Aendern"
	sTrennzeichen = ";"
	sParameter = sAend_User & ";" & sBelegRecordid & ";" & sFirmenRecordid & ";" & sAdressID & ";" & sLieferAdressID
	'ShowMessage(sParameter)
	bsp = (FakturaProcedure( sProcedure,sTrennzeichen,sParameter,sErrorCode & "002"))
   
	if bsp = false Then
		RaiseException("ErrorCode:" & sErrorCode & "002" & vbLF & vbLF & "Interner Fehler. " & vbLF & "Der Vorgang konnte nicht ausgefhrt werden")
		Wscript.Quit
	End If

	'Container Updaten
	cRM.CurrentProject.ActiveViews.ActiveView.Update()

  End Sub
  






'Container Updaten
cRM.CurrentProject.ActiveViews.ActiveView.Update()




Function SplitStingInArray(sString,i)

Dim sTrennzeichen, sStream, sArray, sText, iCounter, v0

sTrennzeichen = "|" 

sStream =sString

  
   If sStream <> "" Then ' Stream auflsen
   
     sArray = Split(sStream, sTrennzeichen)

	sText = ""

	For iCounter = 0 To UBound(sArray)
  		sText = sText & sArray(iCounter) & vbCr & vbLf  
	Next
    'On Error Funktion rein
    On Error Resume Next
	v0 = sArray(i) 
	If  (Err.Number <> 0) Then
		v0  = ""
	End If
	
    On Error GoTo 0
    
    SplitStingInArray = v0

  End if

End Function
