'--------------------------------------------------------------------------------------------------------------
' Faktura-Software Scriptdatei 
' Funktion: Person zum Beleg auswhlen
' Ansicht: 	FakturaBelege
' Script:	FakturaBelege_63_Person_auswaehlen.vbs
' Produkt:	combit Relationship Manager 6
' Autor  :  	Andreas Mller

' Faktura-Software.net macht keine Angaben zu einer bestimmten Eignung der Information in diesem Script
' Irrtmer und Fehler bleiben ausdrcklich vorbehalten und die Angaben erfolgen ohne Gewhr. 
' Die Angaben stellen nur Einzelfallszenarien dar und enthalten keine Garantie der Beschaffenheit 
' der Produkte. 
 
' Copyright (c) by Faktura-Software.net. Alle Rechte vorbehalten.
'--------------------------------------------------------------------------------------------------------------

Option Explicit

<!--#include file="%PRJDIR%\script\CosmoOle.vbs"-->



'--------------------------------------------------------------------------------------------------------------
' Begin Versionierung
'--------------------------------------------------------------------------------------------------------------
Dim sSkriptVersion
sSkriptVersion = "002"
'--------------------------------------------------------------------------------------------------------------
' What's new
'--------------------------------------------------------------------------------------------------------------
' Version 003 
' - 
' Version 002 
' - Rechtsklick ermglicht, relationale Verknpfung zu lsen
'--------------------------------------------------------------------------------------------------------------

Dim sErrorCode, sErrorProjekt, sErrorAnsicht, sErrorSkript

sErrorProjekt   = cRM.CurrentProject.GetSessionProperty("cRM_Projekt_ProjektNr",True)
sErrorAnsicht   = "118"
sErrorSkript    = "063"

sErrorCode =  sErrorProjekt & sErrorAnsicht & sErrorSkript

'--------------------------------------------------------------------------------------------------------------
' Ende Versionierung
'--------------------------------------------------------------------------------------------------------------

Dim sRechtsklick, bPrivatadresse
Dim sProcedure,sTrennzeichen,sParameter,bsp
Dim sAdressID, sLieferAdressID
Dim sTrialDat, sBelegAdresseAktiv, sLieferAdresseAktiv

'nderungsbenutzer ermitteln

Dim sAend_User

sAend_User = cRM.CurrentProject.CurrentUser

If sAend_User = "" Then
  WScript.Quit
End If

'/ nderungsbenutzer ermitteln

'Beleg ermitteln

Dim sBelegRecordid

sBelegRecordid = cRM.CurrentProject.ActiveViews.ActiveView.CurrentRecordSet.CurrentRecordSynchronized.GetContentsByName("Recordid")
 
If sBelegRecordid = "" Then
  WScript.Quit
End If
'/ Beleg ermitteln



 If Not WScript.RightClicked Then 'Person auswhlen
 
		Dim sFilterPerson,sFirmenRecordid,sPersonRecordid
		
		sFirmenRecordid = cRm.CurrentProject.ActiveViews.ActiveView.CurrentRecordSet.CurrentRecordSynchronized.GetContentsByName("Firmen_Recordid")
		
		'Personen eingrenzen, wenn Firma vorhanden ist
		If sFirmenRecordid = "" Then
		  sFilterPerson = "1=1" 
		Else 
		  sFilterPerson = """Contacts"".""CompanyID"" = 0x" & sFirmenRecordid
		End If
		
		sPersonRecordid = OpenDialogSelectRecord("Kontakte",sFilterPerson,"ID","Person auswhlen","Keine Person gefunden. Die Auswahl wird abgebrochen.")
		
		If sPersonRecordid = "" Then
		  WScript.Quit
		End If
		
		' / Person auswhlen
		
		'---------------------------------------------------------------------------------------------------------------------
		'Modul Faktura_Adressen 
		'---------------------------------------------------------------------------------------------------------------------
		' Dim sAdressID, sLieferAdressID wurde oben deklariert
		
		
		'Auslesen, ob FakturaAdressen aktiv ist 
		Dim sGlobalFilter,sFakturaAdressenAktiv
		
		sGlobalFilter	= "upper(""Factura_Software_Global"".""FS_Recordid"") = upper(N'FS-Modul03')"
				
		sFakturaAdressenAktiv = GetHiddenFieldContentByName("FakturaGlobaleEinstellungen", sGlobalFilter,"Result", "Der Parameter FakturaAdressenAktiv konnte in FakturaGlobaleEinstellungen nicht gefunden werden.")
		'ShowMessage(sFakturaAdressenAktiv)
		sFakturaAdressenAktiv = SplitStingInArray(sFakturaAdressenAktiv,1)
		
		Dim sModulStatus 
		sModulStatus  = sFakturaAdressenAktiv
		
		'ShowMessage(sFakturaAdressenAktiv)
		if UCase(Mid(sModulStatus,1,3)) = UCase("tri") then
		
			On Error Resume Next
				sTrialDat = Right(sFakturaAdressenAktiv,10)
				If (Err.Number <> 0) Then
					Msgbox("Fehler beim Auslesen des Trial Datums" &vbLf  &"Der Vorgang wird ohne das Modul X-Address fortgefhrt.")
					sFakturaAdressenAktiv = "Nein"
			End If
			On Error GoTo 0
		End if
		
		if UCase(Mid(sFakturaAdressenAktiv,1,1)) = UCase("t") then
		  sFakturaAdressenAktiv = "Ja"
		End if
		
		
		'ShowMessage(sFakturaAdressenAktiv)
		
		If sFakturaAdressenAktiv = "Ja" Then 'Adressauswahl
		
		   'Auslesen der Parameter 
		   sGlobalFilter = "upper(""Factura_Software_Global"".""FS_Recordid"") = upper(N'AuswahlBelegEmpf')"
		   
		   sBelegAdresseAktiv = GetHiddenFieldContentByName("FakturaGlobaleEinstellungen", sGlobalFilter,"Result", "Der Parameter FakturaAdressenAktiv konnte in FakturaGlobaleEinstellungen nicht gefunden werden.")
		
		   sGlobalFilter = "upper(""Factura_Software_Global"".""FS_Recordid"") = upper(N'AuswahlLieferEmpf')"
		   
		   sLieferAdresseAktiv = GetHiddenFieldContentByName("FakturaGlobaleEinstellungen", sGlobalFilter,"Result", "Der Parameter FakturaAdressenAktiv konnte in FakturaGlobaleEinstellungen nicht gefunden werden.")
		  
		  Dim sFilterAdresse,sViewAdresse,sFieldAdresse, sErrorAdresse,oView,oRecordSet,bFilter,oCurrentRecord
		  
		  
		  'Auslesen Adresse 1: Belegadresse
		  If sBelegAdresseAktiv = "Ja" Then
		  
		  
		  
				sFilterAdresse = """Factura_Adressen_Zuordnung"".""CompanyID"" = 0x" & sFirmenRecordid & " And ""Factura_Adressen_Zuordnung"".""Belegadresse"" = 1"
				sViewAdresse   ="FakturaAdressZuordnung"
				sFieldAdresse  ="AddressID"
				sErrorAdresse  ="Keine Belegadresse vorhanden. Der Beleg wird mit der Hauptadresse der Firma befllt."
				
				'sAdressID = OpenDialogSelectRecordDontQuit(sViewAdresse, sFilterAdresse,sFieldAdresse,"Auswahl der Belegadresse", sErrorAdresse)
				
				
				Set oView = cRM.CurrentProject.ViewConfigs.ItemByName(sViewAdresse)
				
				Set oRecordSet = oView.CreateRecordSet
				
				bFilter = oRecordSet.SetFilter(sFilterAdresse)
				
				If bFilter Then 'Filter OK
					If oRecordSet.Reccount > 1 Then
					  'Wenn Trial dann Medlung
					   if ((sLieferAdresseAktiv = "Ja") or  (sBelegAdresseAktiv = "Ja")) and (len(sTrialDat)>3)  then
					      ShowMEssage("Trial gltig bis zum: " &sTrialDat)
					   End if
				
		
					  Set oCurrentRecord = oRecordSet.DialogSelectRecord("Auswahl der Belegadresse")
					  
					  'Set oCurrentRecord =  oRecordSet.CurrentRecordSynchronized
					  If oCurrentRecord Is Nothing Then  
					   sAdressID = "Null"
					  Else 
					    sAdressID = oCurrentRecord.GetContentsByName(sFieldAdresse)
					  End If
					  
					    
					ElseIf oRecordSet.MoveFirst Then 
					  
					  Set oCurrentRecord =  oRecordSet.CurrentRecordSynchronized
					  
					   sAdressID = oCurrentRecord.GetContentsByName(sFieldAdresse)
					
					Else 
					  sAdressID = "Null"
					  'showmessage(sErrorAdresse)
					End If
				
				Else 'Filter Ok
				  sAdressID = "Null"
				  'showmessage(sErrorAdresse)
				End If ' /Filter OK
				
				
		  Else sAdressID = "Null"
		  
		  End If
		  
		 'Auslesen Adresse 2: Lieferadresse
		 If sLieferAdresseAktiv = "Ja" Then
		 
				sViewAdresse   ="FakturaAdressZuordnung"
				sFieldAdresse  ="AddressID"
			    sFilterAdresse = """Factura_Adressen_Zuordnung"".""CompanyID"" = 0x" & sFirmenRecordid & " And ""Factura_Adressen_Zuordnung"".""Lieferadresse"" = 1"
				sErrorAdresse  ="Keine Lieferadressen vorhanden. Der Beleg wird mit der Lieferadresse der Firma befllt, sofern vorhanden."
				
				'sLieferAdressID = OpenDialogSelectRecordDontQuit(sViewAdresse, sFilterAdresse,sFieldAdresse,"Auswahl der Lieferadresse", sErrorAdresse)
				Set oView = cRM.CurrentProject.ViewConfigs.ItemByName(sViewAdresse)
				
				Set oRecordSet = oView.CreateRecordSet
				
				bFilter = oRecordSet.SetFilter(sFilterAdresse)
				
				If bFilter Then 'Filter OK
					If oRecordSet.Reccount > 1 Then
					
					  Set oCurrentRecord = oRecordSet.DialogSelectRecord("Auswahl der Belegadresse")
					  
					  'Set oCurrentRecord =  oRecordSet.CurrentRecordSynchronized
					  If oCurrentRecord Is Nothing Then  
					   sLieferAdressID = "Null"
					  Else 
					    sLieferAdressID = oCurrentRecord.GetContentsByName(sFieldAdresse)
					  End If
					  
					    
					ElseIf oRecordSet.MoveFirst Then 
					  
					  Set oCurrentRecord =  oRecordSet.CurrentRecordSynchronized
					  
					   sLieferAdressID = oCurrentRecord.GetContentsByName(sFieldAdresse)
					
					Else 
					  sLieferAdressID = "Null"
					  'showmessage(sErrorAdresse)
					End If
				
				Else 'Filter Ok
				  sLieferAdressID = "Null"
				  'showmessage(sErrorAdresse)
				End If ' /Filter OK
				
				
				
				
		  Else sLieferAdressID = "Null"
		
		  
		  End If 
		  
		  
		End If ' / Adressauswahl
		
		'ExecSP()
		
		'---------------------------------------------------------------------------------------------------------------------
		'/ Modul Faktura_Adressen 
		'---------------------------------------------------------------------------------------------------------------------
		
		
		' ----- 2. Ausfhren der Stored Procedure -----
		
'		Dim sProcedure, sTrennzeichen, sParameter

		
		   	
				sProcedure = "Fs_Beleg_Person_Aendern"
				sTrennzeichen = ";"
				sParameter = sAend_User & ";" & sBelegRecordid & ";" & sPersonRecordid & ";" & sAdressID & ";" & sLieferAdressID
		
		   		bsp = (FakturaProcedure( sProcedure,sTrennzeichen,sParameter,sErrorCode & "001"))
		   
				    If bsp = False Then
				      'RaiseException("ErrorCode:" & sErrorCode & "001" & vbLF & vbLF & "Interner Fehler. " & vbLF & "Der Vorgang konnte nicht ausgefhrt werden")
				      Wscript.Quit
				     End If
		  
		'---------------------------------------------------------------------------------------------------------------------
		'/ Modul Faktura_Adressen 
		'---------------------------------------------------------------------------------------------------------------------
	
  Else
    'ShowMessage("rechts")
    'Person entfernen
    sPersonRecordid = "Entfernen"
    
    ' Stored Procedure ausfhren
		

		sProcedure = "Fs_Beleg_Person_Aendern"
		sTrennzeichen = ";"
		sParameter = sAend_User & ";" & sBelegRecordid & ";" & sPersonRecordid

   		bSP = (FakturaProcedure( sProcedure,sTrennzeichen,sParameter,sErrorCode & "001"))
   
		    If bsp = False Then
		      'RaiseException("ErrorCode:" & sErrorCode & "001" & vbLF & vbLF & "Interner Fehler. " & vbLF & "Der Vorgang konnte nicht ausgefhrt werden")
		      Wscript.Quit
		     End If
    
  
  End If



		
'Container Updaten
cRM.CurrentProject.ActiveViews.ActiveView.Update()


Function SplitStingInArray(sString,i)

Dim sTrennzeichen, sStream, sArray, sText, iCounter, v0

sTrennzeichen = "|" 

sStream =sString

  
   If sStream <> "" Then ' Stream auflsen
   
     sArray = Split(sStream, sTrennzeichen)

	sText = ""

	For iCounter = 0 To UBound(sArray)
  		sText = sText & sArray(iCounter) & vbCr & vbLf  
	Next
    'On Error Funktion rein
    On Error Resume Next
	v0 = sArray(i) 
	If  (Err.Number <> 0) Then
		v0  = ""
	End If
	
    On Error GoTo 0
    
    SplitStingInArray = v0

  End if

End Function


