'--------------------------------------------------------------------------------------------------------------
' cosmolink Scriptdatei 
' Funktion: Hinzufgen einer FakturaAdresse 
' Ansicht:  Kontakte
' Script:	Kontakte_15_Neue_FakturaAdresse.vbs
' Produkt:	combit Relationship Manager 6
' Autor  :  Dr. Frank Wietzel

' cosmolink e.K. macht keine Angaben zu einer bestimmten Eignung der Information in diesem Script
' Irrtmer und Fehler bleiben ausdrcklich vorbehalten und die Angaben erfolgen ohne Gewhr. 
' Die Angaben stellen nur Einzelfallszenarien dar und enthalten keine Garantie der Beschaffenheit 
' der Produkte. 
 
' Copyright (c) by cosmolink e.K. Alle Rechte vorbehalten.
'--------------------------------------------------------------------------------------------------------------

' Version 02:
' fehlende DLL zu "crm.DialogForm" abgefangen und Meldung ausgeben

Option Explicit
<!--#include file="%PRJDIR%\script\CosmoOle.vbs"-->


Dim sCosmolinkInfo, sVersion, sCRMSeriennummer

sVersion = cRM.FileVersion/65535

'ShowMessage(sVersion)

' fehlende DLL abfangen
On Error Resume Next
  	sCRMSeriennummer = cRM.SerialNumber
  	'ShowMessage(sCRMSeriennummer)
  	If (Err.Number <> 0) Then
  	 	Msgbox("Sie verwenden nicht die aktuellste Version des cRM6." &vbLf  &vbLf &"Die Freischaltung der cosmolink Faktura ist erst ab der cRM Verion 6.005 mglich." &vbLf &vbLf &"Der Vorgang wird beendet.")
   		WScript.Quit
End If
On Error GoTo 0


'ShowMessage(sCRMSeriennummer)


sCosmolinkInfo = "Lizenzschlssel erhalten Sie bei Ihrem combit "+ chr(10) + chr(13)_
			& "cRM Solution Partner oder direkt per Email an:" + chr(10) + chr(13) + chr(10) + chr(13)_
			&"cosmolink"+ chr(10) + chr(13) _
			&"Neunkircher Strasse 8"+ chr(10) + chr(13) _
			&"66557 Illingen / Httigweiler"+ chr(10) + chr(13) + chr(10) + chr(13) _
			&"Tel.:    +49 6825 940 640"+ chr(10) + chr(13) _
			&"E-Mail: info@cosmolink.de"+ chr(10) + chr(13) _


'Dialogobjekt erstellen
Dim oDlgObj


' fehlende DLL abfangen
On Error Resume Next
 	Set oDlgObj = crm.DialogForm
 	If ((oDlgObj Is Nothing) OR (Err.Number <> 0)) Then
 	 	showmessage("Ein bentigtes Modul konnte nicht geladen werden. Bitte folgen Sie den Anweisungen des Whitepaper ""cosmolink faktura - Lizenz einspielen.pdf"" unter "" Mgliche Fehlermeldung und Lsung"". Der Vorgang wird beendet.")
  		WScript.Quit
 	End If
On Error GoTo 0
' / fehlende DLL abfangen
			  	
Const ForReading = 1, ForWriting = 2
Dim oFso
Set oFso = CreateObject("Scripting.FileSystemObject")

WScript.ConnectObject oDlgObj,"DIALOG_"

' Dialogtitel festlegen
oDlgObj.DialogTitle = "FakturaAdresse Hinzufgen - cosmolink faktura"
oDlgObj.DLIPath = oFso.GetAbsolutePathName("%PRJDIR%\FakturaAdresseHinzufuegen.dli")

'nderung fwi 12.09.2011
oDlgObj.IconPath = "%APPDIR%\cRM.exe"


oDlgObj.DefineVariableStart

'Variabeln deklarieren
Dim	  sCompany,sCompany2,sCompany3,sCountry,sZIP,sCity,sStreet,sZIPPOBox,sPOBox,sPhone,sFax
Dim	  sEmail,sUserDefined1,sUserDefined2,sUserDefined3,sUserDefined4,sUserDefined5,sZ_Import_PK,sZ_Import_FK,sAddressType,sCompanyID,sContactID
Dim	  sFirstname ,sLastname,sDepartment,sPersonal_Company_Addion1,sPersonal_Company_Addion2,sArea,sSalutation,sSalutationLetter,sCustomerNo,sProceedsAccount,sContraAccount
Dim   bBelegadresse, bLieferadresse, bProjektadresse, bStandordadresse

Dim oCurrentRecordSet		
Set oCurrentRecordSet		= cRM.CurrentProject.ActiveViews.ActiveView.CurrentRecordSet

sCompany					=	oCurrentRecordSet.CurrentRecordSynchronized.GetContentsbyName("CompanyID.Firmen.ID.Company")
sCompany2					=	oCurrentRecordSet.CurrentRecordSynchronized.GetContentsbyName("CompanyID.Firmen.ID.Company2")
sCompany3					=	oCurrentRecordSet.CurrentRecordSynchronized.GetContentsbyName("CompanyID.Firmen.ID.Company3")
sCountry					=	oCurrentRecordSet.CurrentRecordSynchronized.GetContentsbyName("CompanyID.Firmen.ID.Country")
sZIP						=	oCurrentRecordSet.CurrentRecordSynchronized.GetContentsbyName("CompanyID.Firmen.ID.ZIP")
sCity						=	oCurrentRecordSet.CurrentRecordSynchronized.GetContentsbyName("CompanyID.Firmen.ID.City")
sStreet						=	oCurrentRecordSet.CurrentRecordSynchronized.GetContentsbyName("CompanyID.Firmen.ID.Street")
sZIPPOBox					=	oCurrentRecordSet.CurrentRecordSynchronized.GetContentsbyName("CompanyID.Firmen.ID.ZIPPOBox")
sPOBox						=	oCurrentRecordSet.CurrentRecordSynchronized.GetContentsbyName("CompanyID.Firmen.ID.POBox")
sPhone						=	oCurrentRecordSet.CurrentRecordSynchronized.GetContentsbyName("Phone")
sFax						=	oCurrentRecordSet.CurrentRecordSynchronized.GetContentsbyName("Fax")
sEmail						=	oCurrentRecordSet.CurrentRecordSynchronized.GetContentsbyName("Email")
sUserDefined1				=	oCurrentRecordSet.CurrentRecordSynchronized.GetContentsbyName("UserDefined1")
sUserDefined2				=	oCurrentRecordSet.CurrentRecordSynchronized.GetContentsbyName("UserDefined2")
sUserDefined3				=	oCurrentRecordSet.CurrentRecordSynchronized.GetContentsbyName("UserDefined3")
sUserDefined4				=	oCurrentRecordSet.CurrentRecordSynchronized.GetContentsbyName("UserDefined4")
sUserDefined5				=	oCurrentRecordSet.CurrentRecordSynchronized.GetContentsbyName("UserDefined5")
sZ_Import_PK				=	oCurrentRecordSet.CurrentRecordSynchronized.GetContentsbyName("Z_Import_PK")
sZ_Import_FK				=	oCurrentRecordSet.CurrentRecordSynchronized.GetContentsbyName("Z_Import_FK")
sAddressType				= 	oCurrentRecordSet.CurrentRecordSynchronized.GetContentsbyName("ActiveAddress")
sCompanyID					=	oCurrentRecordSet.CurrentRecordSynchronized.GetContentsbyName("CompanyID")
sContactID					=	oCurrentRecordSet.CurrentRecordSynchronized.GetContentsbyName("ID")
sFirstname					=	oCurrentRecordSet.CurrentRecordSynchronized.GetContentsbyName("Firstname")
sLastname					= 	oCurrentRecordSet.CurrentRecordSynchronized.GetContentsbyName("Name")
sDepartment					=	oCurrentRecordSet.CurrentRecordSynchronized.GetContentsbyName("Department")
sPersonal_Company_Addion1	=	oCurrentRecordSet.CurrentRecordSynchronized.GetContentsbyName("Personal_Company_Addion1")
sPersonal_Company_Addion2	=	oCurrentRecordSet.CurrentRecordSynchronized.GetContentsbyName("Personal_Company_Addion2")
sArea						=	oCurrentRecordSet.CurrentRecordSynchronized.GetContentsbyName("Area")
sSalutation					=	oCurrentRecordSet.CurrentRecordSynchronized.GetContentsbyName("Salutation")
sSalutationLetter			=	oCurrentRecordSet.CurrentRecordSynchronized.GetContentsbyName("SalutationLetter")
sCustomerNo					=	oCurrentRecordSet.CurrentRecordSynchronized.GetContentsbyName("CustomerNo")
sProceedsAccount			=	oCurrentRecordSet.CurrentRecordSynchronized.GetContentsbyName("ProceedsAccount")
sContraAccount				=	oCurrentRecordSet.CurrentRecordSynchronized.GetContentsbyName("ContraAccount")

'Felder anlegen

oDlgObj.DefineVariable "Projektnummer", 3, "N", 100,0,""
oDlgObj.DefineVariable "Firma", 0, "C", 100, 0,""
oDlgObj.DefineVariable "Lizenzkey", 0, "C", 100, 0,""
oDlgObj.DefineVariable "sInfo", 0, "C", 300, 0,""
oDlgObj.DefineVariable "combit_Seriennummer", 0, "C", 100, 0,""
oDlgObj.DefineVariable 	 "Company", 0, "C", 100,0,sCompany
oDlgObj.DefineVariable 	 "Company2", 0, "C", 100,0,	sCompany2
oDlgObj.DefineVariable 	 "Company3", 0, "C", 100,0,	sCompany3
oDlgObj.DefineVariable 	 "Country", 0, "C", 3,0,	sCountry
oDlgObj.DefineVariable 	 "ZIP", 0, "C", 9,0,	sZIP
oDlgObj.DefineVariable 	 "City", 0, "C", 50,0,	sCity
oDlgObj.DefineVariable 	 "Street", 0, "C", 50,0,	sStreet
oDlgObj.DefineVariable 	 "ZIPPOBox", 0, "C", 9,0,	sZIPPOBox
oDlgObj.DefineVariable 	 "POBox", 0, "C", 30,0,	sPOBox
oDlgObj.DefineVariable 	 "Phone", 0, "C", 30,0,	sPhone
oDlgObj.DefineVariable 	 "Fax", 0, "C", 30,0,	sFax
oDlgObj.DefineVariable 	 "Email", 0, "C", 150,0,	sEmail
oDlgObj.DefineVariable 	 "UserDefined1", 0, "C", 100,0,	sUserDefined1
oDlgObj.DefineVariable 	 "UserDefined2", 0, "C", 100,0,	sUserDefined2
oDlgObj.DefineVariable 	 "UserDefined3", 0, "C", 100,0,	sUserDefined3
oDlgObj.DefineVariable 	 "UserDefined4", 0, "C", 100,0,	sUserDefined4
oDlgObj.DefineVariable 	 "UserDefined5", 0, "C", 100,0,	sUserDefined5
oDlgObj.DefineVariable 	 "Z_Import_PK", 0, "C", 120,0,	sZ_Import_PK
oDlgObj.DefineVariable 	 "Z_Import_FK", 0, "C", 120,0,	sZ_Import_FK
oDlgObj.DefineVariable 	 "AddressType", 0, "C", 1,0,	sAddressType
oDlgObj.DefineVariable 	 "Firstname", 0, "C", 100,0,	sFirstname
oDlgObj.DefineVariable 	 "Lastname", 0, "C", 100,0,	sLastname
oDlgObj.DefineVariable 	 "Department", 0, "C", 40,0,	sDepartment
oDlgObj.DefineVariable 	 "Personal_Company_Addion1", 0, "C", 100,0,	sPersonal_Company_Addion1
oDlgObj.DefineVariable 	 "Personal_Company_Addion2", 0, "C", 100,0,	sPersonal_Company_Addion2
oDlgObj.DefineVariable 	 "Area", 0, "C", 100,0,	sArea
oDlgObj.DefineVariable 	 "Salutation", 0, "C", 30,0,	sSalutation
oDlgObj.DefineVariable 	 "SalutationLetter", 0, "C", 40,0,	sSalutationLetter
oDlgObj.DefineVariable 	 "CustomerNo", 0, "C", 8,0,	sCustomerNo
oDlgObj.DefineVariable 	 "ProceedsAccount", 0, "C", 7,0,	sProceedsAccount
oDlgObj.DefineVariable 	 "ContraAccount", 0, "C", 7,0, 	sContraAccount
oDlgObj.DefineVariable 	 "Belegadresse", 0, "L", 1,0,"" 
oDlgObj.DefineVariable 	 "Lieferadresse", 0, "L", 1,0,"" 
oDlgObj.DefineVariable 	 "Projektadresse", 0, "L", 1,0,"" 
oDlgObj.DefineVariable 	 "Standordadresse", 0, "L", 1,0,"" 
oDlgObj.DefineFctStart



' Buttons anlegen

oDlgObj.DefineFct "Freischalten", "Lizenzangaben bernehmen", True, True, 0
oDlgObj.DefineFct "Abbrechen", "Beenden", True, True, 1 
oDlgObj.DefineFct "bestellen", "ffnen des Bestellformulars", True, True, 0


'Infofeld anzeigen
oDlgObj.SetVariableContents "sInfo",sCosmolinkInfo
oDlgObj.SetVariableContents "combit_Seriennummer",sCRMSeriennummer

'Angepasste Gre an Eingabemaske
oDlgObj.Sizable = True
oDlgObj.SizeToContent = True
oDlgObj.WidthInPixel = 1200 
oDlgObj.HeightInPixel = 700




'Info: Designaufruf mit Alt + J
oDlgObj.Show

Set oDlgObj 	= Nothing
Set oFso		= Nothing


        

' -------------------------------------------------------------------------------------------------------------------------------
'CauseCallback Event
Sub DIALOG_ExecuteFct(sName)
	Select Case sName
		Case "Abbrechen"
			oDlgObj.Close
		
			
	    Case "Freischalten"
			Freischaltung
			
	    Case "bestellen"
	    		bestellen
	    End Select
	
	'MsgBox "Event: " & sName
End Sub
' -------------------------------------------------------------------------------------------------------------------------------

 
 

' -------------------------------------------------------------------------------------------------------------------------------
Sub bestellen
Dim sPDF

sPDF = "%PRJDIR%\cosmolink faktura bestellung.pdf"

sPDF = """" &sPDF &""""


Execute sPDF


End Sub
' -------------------------------------------------------------------------------------------------------------------------------

' ------------------------------------------------------------------------------------------------------------------------------
Sub Freischaltung
	
  Dim sProjektnummer,sFirma,sLizenzkey,sLizenzcheck
  
     
	'Ebene 1
	oDlgObj.GetVariableContentsVariant "Projektnummer",sProjektnummer
	oDlgObj.GetVariableContentsVariant "Firma",sFirma
	oDlgObj.GetVariableContentsVariant "Lizenzkey",sLizenzkey
													
	'Variabeln auslesen aus der Eingabemaske
	oDlgObj.GetVariableContentsVariant 	"Company"	,	sCompany
	oDlgObj.GetVariableContentsVariant 	"Company2"	,	sCompany2
	oDlgObj.GetVariableContentsVariant 	"Company3"	,	sCompany3
	oDlgObj.GetVariableContentsVariant 	"Country"	,	sCountry
	oDlgObj.GetVariableContentsVariant 	"ZIP"	,	sZIP
	oDlgObj.GetVariableContentsVariant 	"City"	,	sCity
	oDlgObj.GetVariableContentsVariant 	"Street"	,	sStreet
	oDlgObj.GetVariableContentsVariant 	"ZIPPOBox"	,	sZIPPOBox
	oDlgObj.GetVariableContentsVariant 	"POBox"	,	sPOBox
	oDlgObj.GetVariableContentsVariant 	"Phone"	,	sPhone
	oDlgObj.GetVariableContentsVariant 	"Fax"	,	sFax
	oDlgObj.GetVariableContentsVariant 	"Email"	,	sEmail
	oDlgObj.GetVariableContentsVariant 	"UserDefined1"	,	sUserDefined1
	oDlgObj.GetVariableContentsVariant 	"UserDefined2"	,	sUserDefined2
	oDlgObj.GetVariableContentsVariant 	"UserDefined3"	,	sUserDefined3
	oDlgObj.GetVariableContentsVariant 	"UserDefined4"	,	sUserDefined4
	oDlgObj.GetVariableContentsVariant 	"UserDefined5"	,	sUserDefined5
	oDlgObj.GetVariableContentsVariant 	"Z_Import_PK"	,	sZ_Import_PK
	oDlgObj.GetVariableContentsVariant 	"Z_Import_FK"	,	sZ_Import_FK
	oDlgObj.GetVariableContentsVariant 	"AddressType"	,	sAddressType
	oDlgObj.GetVariableContentsVariant 	"Firstname"	,	sFirstname
	oDlgObj.GetVariableContentsVariant 	"Lastname"	,	sLastname
	oDlgObj.GetVariableContentsVariant 	"Department"	,	sDepartment
	oDlgObj.GetVariableContentsVariant 	"Personal_Company_Addion1"	,	sPersonal_Company_Addion1
	oDlgObj.GetVariableContentsVariant 	"Personal_Company_Addion2"	,	sPersonal_Company_Addion2
	oDlgObj.GetVariableContentsVariant 	"Area"	,	sArea
	oDlgObj.GetVariableContentsVariant 	"Salutation"	,	sSalutation
	oDlgObj.GetVariableContentsVariant 	"SalutationLetter"	,	sSalutationLetter
	oDlgObj.GetVariableContentsVariant 	"CustomerNo"	,	sCustomerNo
	oDlgObj.GetVariableContentsVariant 	"ProceedsAccount"	,	sProceedsAccount
	oDlgObj.GetVariableContentsVariant 	"ContraAccount"	,	sContraAccount
	oDlgObj.GetVariableContentsVariant 	"Belegadresse"	,	bBelegadresse
	oDlgObj.GetVariableContentsVariant 	"Lieferadresse", bLieferadresse
	oDlgObj.GetVariableContentsVariant 	"Projektadresse", bProjektadresse
	oDlgObj.GetVariableContentsVariant 	"Standordadresse", bStandordadresse

If (sCompany = " ") Or (Len(sCompany)<1) Then sCompany= "NULL" Else sCompany="'" &sCompany&"'"
If (sCompany2 = " ") Or (Len(sCompany2)<1) Then sCompany2= "NULL" Else sCompany2="'" &sCompany2&"'"
If (sCompany3 = " ") Or (Len(sCompany3)<1) Then sCompany3= "NULL" Else sCompany3="'" &sCompany3&"'"
If (sCountry = " ") Or (Len(sCountry)<1) Then sCountry= "NULL" Else sCountry="'" &sCountry&"'"
If (sZIP = " ") Or (Len(sZIP)<1) Then sZIP= "NULL" Else sZIP="'" &sZIP&"'"
If (sCity = " ") Or (Len(sCity)<1) Then sCity= "NULL" Else sCity="'" &sCity&"'"
If (sStreet = " ") Or (Len(sStreet)<1) Then sStreet= "NULL" Else sStreet="'" &sStreet&"'"
If (sZIPPOBox = " ") Or (Len(sZIPPOBox)<1) Then sZIPPOBox= "NULL" Else sZIPPOBox="'" &sZIPPOBox&"'"
If (sPOBox = " ") Or (Len(sPOBox)<1) Then sPOBox= "NULL" Else sPOBox="'" &sPOBox&"'"
If (sPhone = " ") Or (Len(sPhone)<1) Then sPhone= "NULL" Else sPhone="'" &sPhone&"'"
If (sFax = " ") Or (Len(sFax)<1) Then sFax= "NULL" Else sFax="'" &sFax&"'"
If (sEmail = " ") Or (Len(sEmail)<1) Then sEmail= "NULL" Else sEmail="'" &sEmail&"'"
If (sUserDefined1 = " ") Or (Len(sUserDefined1)<1) Then sUserDefined1= "NULL" Else sUserDefined1="'" &sUserDefined1&"'"
If (sUserDefined2 = " ") Or (Len(sUserDefined2)<1) Then sUserDefined2= "NULL" Else sUserDefined2="'" &sUserDefined2&"'"
If (sUserDefined3 = " ") Or (Len(sUserDefined3)<1) Then sUserDefined3= "NULL" Else sUserDefined3="'" &sUserDefined3&"'"
If (sUserDefined4 = " ") Or (Len(sUserDefined4)<1) Then sUserDefined4= "NULL" Else sUserDefined4="'" &sUserDefined4&"'"
If (sUserDefined5 = " ") Or (Len(sUserDefined5)<1) Then sUserDefined5= "NULL" Else sUserDefined5="'" &sUserDefined5&"'"
If (sZ_Import_PK = " ") Or (Len(sZ_Import_PK)<1) Then sZ_Import_PK= "NULL" Else sZ_Import_PK="'" &sZ_Import_PK&"'"
If (sZ_Import_FK = " ") Or (Len(sZ_Import_FK)<1) Then sZ_Import_FK= "NULL" Else sZ_Import_FK="'" &sZ_Import_FK&"'"
If (sAddressType = " ") Or (Len(sAddressType)<1) Then sAddressType= "'F'" Else sAddressType="'" &sAddressType&"'"
If (sCompanyID = " ") Or (Len(sCompanyID)<1) Then sCompanyID= "NULL" Else sCompanyID="0x" &sCompanyID&""
If (sContactID = " ") Or (Len(sContactID)<1) Then sContactID= "NULL" Else sContactID="0x" &sContactID&""
If (sFirstname = " ") Or (Len(sFirstname)<1) Then sFirstname= "NULL" Else sFirstname="'" &sFirstname&"'"
If (sLastname = " ") Or (Len(sLastname)<1) Then sLastname= "NULL" Else sLastname="'" &sLastname&"'"
If (sDepartment = " ") Or (Len(sDepartment)<1) Then sDepartment= "NULL" Else sDepartment="'" &sDepartment&"'"
If (sPersonal_Company_Addion1 = " ") Or (Len(sPersonal_Company_Addion1)<1) Then sPersonal_Company_Addion1= "NULL" Else sPersonal_Company_Addion1="'" &sPersonal_Company_Addion1&"'"
If (sPersonal_Company_Addion2 = " ") Or (Len(sPersonal_Company_Addion2)<1) Then sPersonal_Company_Addion2= "NULL" Else sPersonal_Company_Addion2="'" &sPersonal_Company_Addion2&"'"
If (sArea = " ") Or (Len(sArea)<1) Then sArea= "NULL" Else sArea="'" &sArea&"'"
If (sSalutation = " ") Or (Len(sSalutation)<1) Then sSalutation= "NULL" Else sSalutation="'" &sSalutation&"'"
If (sSalutationLetter = " ") Or (Len(sSalutationLetter)<1) Then sSalutationLetter= "NULL" Else sSalutationLetter="'" &sSalutationLetter&"'"
If (sCustomerNo = " ") Or (Len(sCustomerNo)<1) Then sCustomerNo= "NULL" Else sCustomerNo="'" &sCustomerNo&"'"
If (sProceedsAccount = " ") Or (Len(sProceedsAccount)<1) Then sProceedsAccount= "NULL" Else sProceedsAccount="'" &sProceedsAccount&"'"
If (sContraAccount = " ") Or (Len(sContraAccount)<1) Then sContraAccount= "NULL" Else sContraAccount="'" &sContraAccount&"'"





If (bBelegadresse <> "T") And  (bLieferadresse <> "T") And (bProjektadresse <> "T") And (bStandordadresse <> "T") Then
	ShowMessage("Es muss mindestens eine <Addresse verwenden als> ausgewhlt werden. " &vbLf &vbLf &"Die Funktion wird beendet." &vbLf )
	'oDlgObj.Close
	'WScript.Quit
	Exit Sub 
End If			

Dim sErfUser, sSessionId, sSQLInsert

sSessionId		= "'" &GetGuid() &"'"
sErfUser       	= cRM.CurrentProject.CurrentUser

sSQLInsert =  "INSERT INTO  " &vbLf _
			& "    dbo.Factura_Adressen  " &vbLf _
			& "( " &vbLf _
			& "  ID, " &vbLf _
			& "  Company, " &vbLf _
			& "  Company2, " &vbLf _
			& "  Company3, " &vbLf _
			& "  Country, " &vbLf _
			& "  ZIP, " &vbLf _
			& "  City, " &vbLf _
			& "  Street, " &vbLf _
			& "  ZIPPOBox, " &vbLf _
			& "  POBox, " &vbLf _
			& "  Phone, " &vbLf _
			& "  Fax, " &vbLf _
			& "  Email, " &vbLf _
			& "  UserDefined1, " &vbLf _
			& "  UserDefined2, " &vbLf _
			& "  UserDefined3, " &vbLf _
			& "  UserDefined4, " &vbLf _
			& "  UserDefined5, " &vbLf _
			& "  CreatedOn, " &vbLf _
			& "  CreatedBy, " &vbLf _
			& "  Z_Import_PK, " &vbLf _
			& "  Z_Import_FK, " &vbLf _
			& "  AddressType, " &vbLf _
			& "  CompanyID, " &vbLf _
			& "  ContactID, " &vbLf _
			& "  Firstname, " &vbLf _
			& "  Lastname, " &vbLf _
			& "  Department, " &vbLf _
			& "  Personal_Company_Addion1,  " &vbLf _
			& "  Personal_Company_Addion2, " &vbLf _
			& "  Area, " &vbLf _
			& "  Salutation, " &vbLf _
			& "  SalutationLetter, " &vbLf _
			& "  CustomerNo, " &vbLf _
			& "  ProceedsAccount, " &vbLf _
			& "  ContraAccount " &vbLf _
			& ")  " &vbLf _
			& "VALUES ( " &vbLf _
			& " " &	sSessionId	&"," &vbLf _
			& " " &	sCompany	&"," &vbLf _
			& " " &	sCompany2	&"," &vbLf _
			& " " &	sCompany3	&"," &vbLf _
			& " " &	sCountry	&"," &vbLf _
			& " " &	sZIP	&"," &vbLf _
			& " " &	sCity	&"," &vbLf _
			& " " &	sStreet	&"," &vbLf _
			& " " &	sZIPPOBox	&"," &vbLf _
			& " " &	sPOBox	&"," &vbLf _
			& " " &	sPhone	&"," &vbLf _
			& " " &	sFax	&"," &vbLf _
			& " " &	sEmail	&"," &vbLf _
			& " " &	sUserDefined1	&"," &vbLf _
			& " " &	sUserDefined2	&"," &vbLf _
			& " " &	sUserDefined3	&"," &vbLf _
			& " " &	sUserDefined4	&"," &vbLf _
			& " " &	sUserDefined5	&"," &vbLf _
			& " " &	"GETDATE()"	&"," &vbLf _
			& " '" &	sErfUser	&"'," &vbLf _
			& " " &	sZ_Import_PK	&"," &vbLf _
			& " " &	sZ_Import_FK	&"," &vbLf _
			& " " &	sAddressType	&"," &vbLf _
			& " " &	sCompanyID	&"," &vbLf _
			& " " &	sContactID	&"," &vbLf _
			& " " &	sFirstname	&"," &vbLf _
			& " " &	sLastname	&"," &vbLf _
			& " " &	sDepartment	&"," &vbLf _
			& " " &	sPersonal_Company_Addion1	&"," &vbLf _
			& " " &	sPersonal_Company_Addion2	&"," &vbLf _
			& " " &	sArea	&"," &vbLf _
			& " " &	sSalutation	&"," &vbLf _
			& " " &	sSalutationLetter	&"," &vbLf _
			& " " &	sCustomerNo	&"," &vbLf _
			& " " &	sProceedsAccount	&"," &vbLf _
			& " " &	sContraAccount	&" " &vbLf _
			& "); " &vbLf 

'ShowMessage (sSQLInsert)
Dim bSQL

'Insert ausfhren
bSQL = SQLShell.ExecuteCommandRaw(sSQLInsert)

Dim sAddressID

sAddressID 		= sSessionId
sSessionId		= "'" &GetGuid() &"'"

If (sCompanyID = " ") Or (Len(sCompanyID)<1) Then sCompanyID= "NULL" Else sCompanyID =   sCompanyID 
If (sContactID = " ") Or (Len(sContactID)<1) Then sContactID= "NULL" Else sContactID =   sContactID 
If (bBelegadresse = " ") Or (bBelegadresse = "F") Or (Len(bBelegadresse)<1) Then bBelegadresse= "NULL" Else bBelegadresse= "1" 
If (bLieferadresse = " ") Or (bLieferadresse = "F") Or (Len(bLieferadresse)<1) Then bLieferadresse= "NULL" Else bLieferadresse= "1" 
If (bProjektadresse = " ") Or (bProjektadresse = "F") Or (Len(bProjektadresse)<1) Then bProjektadresse= "NULL" Else bProjektadresse= "1" 
If (bStandordadresse = " ") Or (bStandordadresse = "F") Or (Len(bStandordadresse)<1) Then bStandordadresse= "NULL" Else bStandordadresse= "1" 


sSQLInsert =  "INSERT INTO  " &vbLf _
			& "  dbo.Factura_Adressen_Zuordnung " &vbLf _
			& "  ( " &vbLf _
			& "    ID, " &vbLf _
			& "    CompanyID, " &vbLf _
			& "    ContactID, " &vbLf _
			& "    AddressID, " &vbLf _
			& "    Belegadresse, " &vbLf _
			& "    Lieferadresse, " &vbLf _
			& "    Projektadresse, " &vbLf _
			& "    Standordadresse " &vbLf _			
			& "  )  " &vbLf _
			& "  VALUES ( " 	& vbLf _
			& " " &sSessionId 		&"," &vbLf _
			& " " &sCompanyID		&"," &vbLf _
			& " " &sContactID		&"," &vbLf _
			& " " &sAddressID		&"," &vbLf _
			& " " &bBelegadresse	&"," &vbLf _
			& " " &bLieferadresse	&"," &vbLf _
			& " " &bProjektadresse	&"," &vbLf _
			& " " &bStandordadresse	&" " &vbLf _
			& "  );	 " &vbLf _


'ShowMessage (sSQLInsert)
'Insert ausfhren
bSQL = SQLShell.ExecuteCommandRaw(sSQLInsert)

Dim nResult, bFehler 

If nResult = -1 Then
   If SQLShell.LastError.ErrorCode=0 Then
     bFehler = False
     'Ansicht aktualisieren
     cRM.CurrentProject.ActiveViews.ActiveView.Update
   Else
     MsgBox SQLShell.LastError.ErrorCode & ": " & SQLShell.LastError.ErrorText
     bFehler = True
   End If
End If

	
End Sub

'Ansicht aktualisieren
cRM.CurrentProject.ActiveViews.ActiveView.Update
     
Function SQLText(sText)

Dim sNewSqlText
Dim nResult

sNewSqlText = StringReplace (sText, "GO |#|", ";")
sNewSqlText = StringReplace (sNewSqlText, "|#|", chr(13)+chr(10))

SQLText = sNewSqlText

End Function










Function GetGuid()
  Dim TypeLib
    Set TypeLib = CreateObject("Scriptlet.TypeLib")
    GetGuid = Left(CStr(TypeLib.Guid), 38)
    GetGuid = Mid(GetGuid,2,36)
    Set TypeLib = Nothing
End Function

